



;               ciforth : a generic I86 ISO FORTH by HCC FIG

; $Id: ci86.gnr,v 3.275 2001/12/14 00:01:31 albert Exp $
; Copyright (2000): Albert van der Horst, HCC FIG Holland by GNU Public License
;
;HCC FIG Holland : Hobby Computer Club, Forth Interest Group  Holland
        ;  66,106
 ;   ciforth $Revision: 3.275 $
;
; For the generic system (to generate ciforth in an other configuration than this one):
;     http://home.hccnet.nl/a.w.m.van.der.horst/ci86gnr.html
;
; If this is a configured assembly file, it should be accompanied with configured
; documentation (texinfo, ps, html.)
; WITHOUT THE DOCUMENTATION: GIVE UP! GET THE REAL THING!
; You have a configured system, if there are NO curly brackets on the next line.
;                          
;
; Configuration of this particular version:
; 32-bits protected mode 
; running under Linux  ;  with c-routines for I/O 
; Normally ciforth doesn't observe ISO >IN.
; Contains :
; (there may be no items here.)
;        Security words
;         Loadable words, i.e. all of ISO CORE, more than is needed
;           for a self contained kernel.
;
 ;
; This is a NASM version of ciforth created by ``m4'' from the generic listing.
; It can be assembled using ``nasm'' obtainable via :
; Source: ftp://ftp.us.kernel.org/pub/software/devel/nasm/source/
; URL: http://www.cryogen.com/Nasm/

; This source is to be linked with c-code. You are referred to the
; information in the generic system for building the executable.
; In general be warned that GNU(-Linux) is hard on those linking c
;  with assembler code.
 
; For assembling on other systems where nasm is available see the
; documentation of nasm.

%if 0
        A generic version of ISO FORTH for IBM type standard PC's
                Albert van der Horst
                HCC Forth user group
                The Netherlands
                www.forth.hccnet.nl

              based on
              FIG-FORTH
   implemented by:  Charlie Krajewski
                    205 ( BIG ) Blue Rd.
                    Middletown, CT  06457

  The listing has been made possible by the
  prior work of:
               Thomas Newman, Hayward, Ca.

 : other_acknowledgements
         John_Cassidy
         Kim_Harris
         George_Flammer
         Robert_D._Villwock ;

 : for tools
         Richard M. Stallman
         Linus Torvalds

No one who programs with FORTH can afford to be without:
  "Starting Forth  by Leo Brodie" and "Thinking Forth by Leo Brodie".
   Both out of print.

This Forth is a descendant in the 300+ (RCS)- generations from fig-Forth.

For nostalgic reasons the following comment has never been removed:
   Although there is much to be said for typing in your own
   listing and getting it running, there is much to be said
   not typing in your own listing.  If you feel that 100+
   pages of plinking is nutty, contact me for availability
   of a disc with source & executable files.  Obtainable at
   a bargain basement price, prepare yourself for bargain
   basement support.

All publications of the FORTH Interest Group are public domain.
They may be further distributed by the inclusion of this
credit notice:
               This publication has been made available by:

               FORTH Interest Group
               P.O. Box 1105
               San Carlos, Ca.  94070
[I feel obliged to keep this last one in (AH). Note that although it is
based on fig-Forth no stone is left unturned.]
%endif
        ;
; ########################################################################################
;                       PREPARATION (no code)
; ########################################################################################
FIGREL  EQU     4       ; FIG RELEASE #
FIGREV  EQU     0       ; FIG REVISION #
USRVER  EQU     0      ; USER VERSION NUMBER, a digit now
;
;      VERY ELEMENTARY .
CW      EQU     4    ; Size of a cell in Forth, not in the bootcode.
ERRORSCREEN EQU     48    ; Screen where the error messages start.
;
;      MEMORY LAYOUT.
; These values can be changed at this single place. 
; They can also be changed at the m4 configuration level.
NBUF    EQU     8    ; No. of buffers aka screens 
KBBUF   EQU     1024      ; Data bytes per disk buffer
US      EQU     40H*CW  ; User variable space
EM      EQU     (1000000H)     ; Where the memory ends w.r.t. ORIG.
EMP     EQU     (EM-1)/1000H+1 ; Number of pages.
RTS     EQU     10000H    ; Return stack & terminal input buffer
;

;
;      ASCII CHARACTER EQUIVALENTS
;
ABL     EQU     ' '     ; SPACE
ACR     EQU     0DH     ; CR
ASO     EQU     '['     ; SQUARE BRACKET OPEN 
ASC     EQU     ']'     ; SQUARE BRACKET CLOSE 
ADOT    EQU     '.'     ; PERIOD
ALF      EQU     0AH     ; LINE FEED, USED INTERNALLY AS
                        ; LINE ENDER
AFF      EQU     0CH     ; FORM FEED
BELL    EQU     07H     ; ^G
BSIN    EQU     08H     ; INPUT DELETE CHARACTER
BSOUT   EQU     08H     ; OUTPUT BACKSPACE ( ^H )
;
;      HEADER RELATED EQUATES
B_DUMMY   EQU     01H     ; dea is dummy, from vocabulary link
B_INVIS   EQU     02H     ; dea is invisible, "smudged".
B_IMMED   EQU     04H     ; dea is a immediate.
B_DENOT   EQU     08H     ; dea is a denotation.
C_HOFFSET EQU     0       ; Offsets of code field in cells, w.r.t. dea
D_HOFFSET EQU     1       ; Same for data field
F_HOFFSET EQU     2       ; Same for flag field
L_HOFFSET EQU     3       ; Same for link field
N_HOFFSET EQU     4       ; Same for name field
PH_OFFSET EQU     5   ; Past header field: Start of data area. 
BD_OFFSET EQU     5+1 ; Start of BODY for CREATEd word.
;
 ;  

;

;

BPS     EQU     512             ;Bytes/sector, common to all of MSDOS
SPB     EQU     KBBUF/BPS
;
;

;
;

;
; 


SEEK_SET   EQU   0x0
TCGETS   EQU   0x5401
TCSETS   EQU   0x5402
ECHO   EQU   0x8
EAGAIN   EQU   0xb
EINTR   EQU   0x4
EPIPE   EQU   0x20
VMIN   EQU   0x6
VTIME   EQU   0x5
ICANON   EQU   0x2
O_RDWR   EQU   0x2
O_RDONLY   EQU   0x0
O_WRONLY   EQU   0x1
O_CREAT   EQU   0x40
O_NONBLOCK   EQU   0x800
SIZE_TERMIO   EQU   0x24
; Numbers of system calls. See "Linux kernel Internals" Appendix A. 
; By M.Beck, H. Boehme e.a. Addison Wesley.                         
; The system calls themselves are extensively documented in chapter 
; 2 of the man pages, e.g. "man 2 exit"
exit   EQU   0x1
open   EQU   0x5
close   EQU   0x6
creat   EQU   0x8
unlink   EQU   0xa
chdir   EQU   0xc
read   EQU   0x3
select   EQU   0x52
_newselect   EQU   0x8e
write   EQU   0x4
ioctl   EQU   0x36
ioperm   EQU   0x65
lseek   EQU   0x13
execve   EQU   0xb
fork   EQU   0x2
waitpid   EQU   0x7
; ------------------------------------------------------------      
;   End of constants stolen from C.                                 
; ------------------------------------------------------------      

RAWIO           EQU     (ECHO | ICANON)
        global  _start        ; Entry point. Called from c. Remainder c-routines to be called from here. 
        extern  c_type,c_expec,c_key,c_qterm
        extern  c_rslw, c_block_exit, c_block_init, c_debug
        global  ciforth
; 
; 


        section forth progbits write exec alloc
        ;
; 

; ########################################################################################
;                      BOOTCODE    (optional, always real mode)
; ########################################################################################

; All bootcode must be relocatable and its memory references absolute.
; Not for the sake of booting, but to allow MSDOS to start the program too. 

        ;    SEGMENT PARA PUBLIC 'CODE'
        ; CS:;,DS:;,SS:;,ES:;
    
    
ORG0:

; 

; 
; 
NOBOOT:         ; Skip till here if not booting.

; 
ENDBOOT:

; ########################################################################################
;                       ADJUST CODE SEGMENT REGISTER (still real mode)
; ########################################################################################
; Required start of .COM program.

; ########################################################################################
;                       MOVE CODE TO ITS PLACE (still real mode)
; ########################################################################################
;
; ########################################################################################
;                       FILL GDT AND SWITCH TO PROTECTED MODE/32 BITS (optional)
; ########################################################################################
; 

; 
; 

; 
; ########################################################################################
;                       PREPARE FOR USING DPMI (OPTIONAL)
; ########################################################################################
;
;

;


;************************
BITS   32         ; Assembler directive

;************************

; 

; ########################################################################################
;                       FORTH GLUE CODE (optional, except for the jump)
; ########################################################################################


SAVE_LINUX:     DD      0,0,0,0,0 ; ESP, EBP, ESI, EDI, EBX
RETURN_LINUX:
        MOV     ESP, LONG[SAVE_LINUX+(CW*(0))]
        MOV     EBP, LONG[SAVE_LINUX+(CW*(1))]
        MOV     ESI, LONG[SAVE_LINUX+(CW*(2))]
        MOV     EDI, LONG[SAVE_LINUX+(CW*(3))]
        MOV     EBX, LONG[SAVE_LINUX+(CW*(4))]
        RET     ; Assuming the old stack has not been disturbed.It shouldn't.
ciforth:
        MOV      LONG[SAVE_LINUX+(CW*(0))],ESP
        MOV      LONG[SAVE_LINUX+(CW*(1))],EBP
        MOV      LONG[SAVE_LINUX+(CW*(2))],ESI
        MOV      LONG[SAVE_LINUX+(CW*(3))],EDI
        MOV      LONG[SAVE_LINUX+(CW*(4))],EBX
        LEA     ECX,[ESP+(CW*(1))]
        XOR     EAX,EAX
        CMP     EAX, LONG[ECX]
        JZ     ENDIF1
        JMP     WARM_ENTRY         ; Warm start
ENDIF1:

 ; 

;
COLD_ENTRY:
        CLD                     ; DIR = INC

        MOV     AX,DS
        MOV     SS,AX           ;Atomic with next instruction.
        MOV     ESP, LONG[USINI+(CW*(2))]    ;PARAM. STACK
        MOV     EBP, LONG[USINI+(CW*(3))]    ;RETURN STACK
        MOV     ESI, CLD1  ; (IP) <-
        JMP NEXT
;
CLD1:   DD      COLD    ;  This is a piece of headerless high level code.
;
; ########################################################################################
;                       FORTH ITSELF (entry point : BOOTUP)
; ########################################################################################
;
%if 0
   FORTH REGISTERS
   The names under FORTH are used in the generic source.

   FORTH   8088     FORTH PRESERVATION RULES
   -----   ----     ----- ------------ -----
   HIP   ESI      High level Interpreter Pointer.  Must be preserved
                    across FORTH words.

   WOR   EAX      Working register.  When entering a word
                    via its code field the DEA is passed in WOR.

   SPO   ESP      Parameter stack pointer.  Must be preserved
                    across FORTH words.

   RPO   EBP      Return stack pointer.  Must be preserved across
                    FORTH words.

            EAX      General register.  Used to pass data from
                    FORTH words, see label APUSH or macro _APUSH

            EDX      General register.  Used to pass more data from
                    FORTH words, see label DPUSH or macro _DPUSH

            EBX      General purpose register.

            ECX      General purpose register.

            CS      Segment register. Must be preserved
                    across FORTH words.

            DS      ditto

            SS      ibid

            ES      Temporary segment register only used by
                    a few words. However it MUST remain equal to
                    DS, such that string primitives can be used
                    with impunity.

----------------------------------------------------------
%endif
        ;
%if 0
---------------------------------------------

   COMMENT CONVENTIONS
   ------- -----------

   =       IS EQUAL TO
   <-      ASSIGNMENT

  NAME        =  Address of name
  (NAME)      =  Contents of name

  CFA         =  CODE FIELD: a pointer to executable code
  DFA         =  PARAMETER FIELD: a pointer into
  FFA         =  FLAG FIELD: contains flags
  LFA         =  LINK FIELD: a pointer
  NFA         =  NAME FIELD: a pointer to a variable number of chars
  PHA         =  POST HEADER ADDRESS

  S1          =  Parameter stack - 1st cell
  S2          =  Parameter stack - 2nd cell
  R1          =  Return stack    - 1st cell
  R2          =  Return stack    - 2nd cell

  LSB         =  Least significant bit
  MSB         =  Most  significant bit
  LB          =  Low byte
  HB          =  High byte
  LW          =  Low  cell

------------------------------------------------------------
%endif
; 
        ;
; 
;
; 
; In 32 bit versions there may be no jumps to NEXT at all 
; The label NEXT1 is rarely relevant (for _OLDDEBUG_) 
DPUSH:  PUSH    EDX      ; Fall through.
APUSH:  PUSH    EAX
NEXT:

; 
 ; 
        LODSD           ;AX <- (IP)
NEXT1:  MOV     EAX,EAX   ; (WOR) <- (IP)

        JMP      LONG[EAX]    ; TO `CFA'
;
;       Dictionary starts here.

DP0:
; Vocabularies all end in a link to 0.
; Only the word FORTH links to the DENOTATION wordlist,
; that in turn links to 0.


;  *********
;  *   '   *
;  *********
;
N_TICK:   DD      1
        DB      "'"
TICK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED + B_DENOT
        DD    0
        DD    N_TICK

        DD      LPWORD, LDUP, TOR
        DD      FOUND
        DD      LDUP, ZEQU
        DD      LIT, 11, QERR
        DD      LDUP, TNFA, FETCH, FETCH ;  Get precise length.
        DD      FROMR, EQUAL, ZEQU
        DD      LIT, 11, QERR ;  to prevent match for denotation.
        DD      LITER
        DD      SEMIS
;

;  *********
;  *   &   *
;  *********
;
N_DCHAR:   DD      1
        DB      "&"
DCHAR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED + B_DENOT
        DD    TICK-(CW*(C_HOFFSET))
        DD    N_DCHAR

        DD      INBRS
        DD      SWAP, DROP
        DD      LDUP, QBL
        DD      LIT, 10, QERR
        DD      LITER
        DD      QDELIM
        DD      SEMIS
;

;  *********
;  *   ^   *
;  *********
;
N_DCTL:   DD      1
        DB      "^"
DCTL:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED + B_DENOT
        DD    DCHAR-(CW*(C_HOFFSET))
        DD    N_DCTL

        DD      INBRS
        DD      SWAP, DROP
        DD      LDUP, QBL
        DD      LIT, 10, QERR
        DD      LIT, '@', LSUB
        DD      LITER
        DD      QDELIM
        DD      SEMIS
;

;  *********
;  *   0   *
;  *********
;
N_DEN0:   DD      1
        DB      "0"
DEN0:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DCTL-(CW*(C_HOFFSET))
        DD    N_DEN0

;  *********
;  *   1   *
;  *********
;
N_DEN1:   DD      1
        DB      "1"
DEN1:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN0-(CW*(C_HOFFSET))
        DD    N_DEN1

;  *********
;  *   2   *
;  *********
;
N_DEN2:   DD      1
        DB      "2"
DEN2:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN1-(CW*(C_HOFFSET))
        DD    N_DEN2

;  *********
;  *   3   *
;  *********
;
N_DEN3:   DD      1
        DB      "3"
DEN3:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN2-(CW*(C_HOFFSET))
        DD    N_DEN3

;  *********
;  *   4   *
;  *********
;
N_DEN4:   DD      1
        DB      "4"
DEN4:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN3-(CW*(C_HOFFSET))
        DD    N_DEN4

;  *********
;  *   5   *
;  *********
;
N_DEN5:   DD      1
        DB      "5"
DEN5:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN4-(CW*(C_HOFFSET))
        DD    N_DEN5

;  *********
;  *   6   *
;  *********
;
N_DEN6:   DD      1
        DB      "6"
DEN6:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN5-(CW*(C_HOFFSET))
        DD    N_DEN6

;  *********
;  *   7   *
;  *********
;
N_DEN7:   DD      1
        DB      "7"
DEN7:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN6-(CW*(C_HOFFSET))
        DD    N_DEN7

;  *********
;  *   8   *
;  *********
;
N_DEN8:   DD      1
        DB      "8"
DEN8:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN7-(CW*(C_HOFFSET))
        DD    N_DEN8

;  *********
;  *   9   *
;  *********
;
N_DEN9:   DD      1
        DB      "9"
DEN9:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN8-(CW*(C_HOFFSET))
        DD    N_DEN9

;  *********
;  *   A   *
;  *********
;
N_DENA:   DD      1
        DB      "A"
DENA:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEN9-(CW*(C_HOFFSET))
        DD    N_DENA

;  *********
;  *   B   *
;  *********
;
N_DENB:   DD      1
        DB      "B"
DENB:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DENA-(CW*(C_HOFFSET))
        DD    N_DENB

;  *********
;  *   C   *
;  *********
;
N_DENC:   DD      1
        DB      "C"
DENC:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DENB-(CW*(C_HOFFSET))
        DD    N_DENC

;  *********
;  *   D   *
;  *********
;
N_DEND:   DD      1
        DB      "D"
DEND:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DENC-(CW*(C_HOFFSET))
        DD    N_DEND

;  *********
;  *   E   *
;  *********
;
N_DENE:   DD      1
        DB      "E"
DENE:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DEND-(CW*(C_HOFFSET))
        DD    N_DENE

;  *********
;  *   F   *
;  *********
;
N_DENF:   DD      1
        DB      "F"
DENF:        DD    DOCOL
        DD    LNUMB
        DD    B_IMMED + B_DENOT
        DD    DENE-(CW*(C_HOFFSET))
        DD    N_DENF

;

;  *********
;  *   -   *
;  *********
;
N_DENM:   DD      1
        DB      "-"
DENM:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED + B_DENOT
        DD    DENF-(CW*(C_HOFFSET))
        DD    N_DENM

        DD      PNUMB, DNEGA, SDLITE
        DD      SEMIS
;

;  *********
;  *   +   *
;  *********
;
N_DENP:   DD      1
        DB      "+"
DENP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED + B_DENOT
        DD    DENM-(CW*(C_HOFFSET))
        DD    N_DENP

        DD      PNUMB, SDLITE
        DD      SEMIS
;

;  *********
;  *   "   *
;  *********
;
N_DENQ:   DD      1
        DB      '"'
DENQ:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED + B_DENOT
        DD    DENP-(CW*(C_HOFFSET))
        DD    N_DENQ

        DD      LIT, SKIP, COMMA        ;  'SKIP , HERE >R 0 ,
        DD      HERE, TOR, ZERO, COMMA
DENQ1:
        DD      LIT, '"', PPARS         ;           BEGIN &" (PARSE)
        DD      INBRS, LDUP, LIT, '"', EQUAL ;           IN[] DUP &" =
        DD      ZBRAN
        DD      DENQ2-$-CW                 ;           WHILE
        DD      TDROP, ONEP             ;           2DROP 1+ R@ $+!
        DD      LDUP, ALLOT, RR, SADD
        DD      BRAN
        DD      DENQ1-$-CW                  ;           REPEAT
DENQ2:
        DD      QBL, ZEQU
        DD      LIT, 10, QERR           ;           ?BLANK 0= 5 ?ERROR
        DD      DROP                    ;                DROP R@ $+!
        DD      LDUP, ALLOT, RR, SADD
        DD      FROMR, SFET, DLITE      ;           R> $@ POSTPONE DLITERAL ;
        DD      SEMIS
;

; The FORTH vocabulary is the only one not to link to zero.
; It links to the DENOTATION vocabulary.
;  *************
;  *   FORTH   *
;  *************
;
N_FORTH:   DD      5
        DB      "FORTH"
FORTH:        DD    DODOE
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    DENOTBODY 
        DD    N_FORTH

        DD      DOVOC
        DD      0       ; END OF VOCABULARY LIST

        DD    0H
        DD    0
        DD    B_DUMMY
        DD    TASK-(CW*(C_HOFFSET))
        DD    0

;
;

;  ************
;  *   CORE   *
;  ************
;
N_CORE:   DD      4
        DB      "CORE"
CORE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    0
        DD    N_CORE

        DD      ZERO    ; Not (fully) present.
        DD      SEMIS
;

;  ***********
;  *   CPU   *
;  ***********
;
N_CPU:   DD      3
        DB      "CPU"
CPU:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CORE-(CW*(C_HOFFSET))
        DD    N_CPU


       DD      LIT, 0CD1856H, ZERO      ; '80386'
           ; '80386'
; 

        DD      SEMIS
;

;  ***************
;  *   VERSION   *
;  ***************
;
N_LVERSION:   DD      7
        DB      "VERSION"
LVERSION:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CPU-(CW*(C_HOFFSET))
        DD    N_LVERSION

%if 0
;       If this is there it is an official release
        DD      SKIP
        DD      22
IBMPC:  DB      'IBM-PC ciforth'
        DB      FIGREL+40H,ADOT,FIGREV+30H,ADOT,USRVER+30H
        DD      LIT, IBMPC, LIT, 22
%endif
;       If this is there it is a beta release
        DD      SKIP
         DD      47
SB0: DB      "beta $RCSfile: ci86.gnr,v $ $Revision: 3.275 $ "
       
        DD      LIT, SB0
        DD      LIT, 47
        DD      SEMIS
;

;  ************
;  *   NAME   *
;  ************
;
N_LNAME:   DD      4
        DB      "NAME"
LNAME:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LVERSION-(CW*(C_HOFFSET))
        DD    N_LNAME

        DD      SKIP
         DD      7
SB1: DB      "ciforth"
       
        DD      LIT, SB1
        DD      LIT, 7
        DD      SEMIS
;

;  ****************
;  *   SUPPLIER   *
;  ****************
;
N_SUPPLIER:   DD      8
        DB      "SUPPLIER"
SUPPLIER:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LNAME-(CW*(C_HOFFSET))
        DD    N_SUPPLIER

        DD      SKIP
         DD      20
SB2: DB      "Albert van der Horst"
       
        DD      LIT, SB2
        DD      LIT, 20
        DD      SEMIS
;
;

;  ******************
;  *   DENOTATION   *
;  ******************
;
N_DENOT:   DD      10
        DB      "DENOTATION"
DENOT:        DD    DODOE
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    FORTH
        DD    N_DENOT

        DD      DOVOC
        DD      FORTH-(CW*(C_HOFFSET))     ; NEXT VOCABULARY 
DENOTBODY:

        DD    0H
        DD    0
        DD    B_DUMMY
        DD    DENQ-(CW*(C_HOFFSET))
        DD    0

;

;  *******************
;  *   ENVIRONMENT   *
;  *******************
;
N_ENV:   DD      11
        DB      "ENVIRONMENT"
ENV:        DD    DODOE
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    DENOT-(CW*(C_HOFFSET))
        DD    N_ENV

        DD      DOVOC
        DD      DENOT-(CW*(C_HOFFSET))       ; NEXT VOCABULARY 

        DD    0H
        DD    0
        DD    B_DUMMY
        DD    SUPPLIER-(CW*(C_HOFFSET))
        DD    0

;

;  ************
;  *   NOOP   *
;  ************
;
N_NOOP:   DD      4
        DB      "NOOP"
NOOP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ENV-(CW*(C_HOFFSET))
        DD    N_NOOP

       JMP NEXT
;
; 
;

;  ***********
;  *   LIT   *
;  ***********
;
N_LIT:   DD      3
        DB      "LIT"
LIT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    NOOP-(CW*(C_HOFFSET))
        DD    N_LIT

        LODSD           ; AX <- LITERAL
        PUSH    EAX
        JMP NEXT          ; TO TOP OF STACK
;

;  ***************
;  *   EXECUTE   *
;  ***************
;
N_EXEC:   DD      7
        DB      "EXECUTE"
EXEC:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LIT-(CW*(C_HOFFSET))
        DD    N_EXEC

        POP     EAX      ; GET XT
        JMP      LONG[EAX + (CW*(C_HOFFSET))]  ;(IP) <- (PFA)
;


;  ***************
;  *   RECURSE   *
;  ***************
;
N_RECURSE:   DD      7
        DB      "RECURSE"
RECURSE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    EXEC-(CW*(C_HOFFSET))
        DD    N_RECURSE

        DD      LATEST, COMMA
        DD      SEMIS
;
;

;  **************
;  *   BRANCH   *
;  **************
;
N_BRAN:   DD      6
        DB      "BRANCH"
BRAN:        DD    (SKIP+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RECURSE-(CW*(C_HOFFSET))
        DD    N_BRAN

;

;  ************
;  *   SKIP   *
;  ************
;
N_SKIP:   DD      4
        DB      "SKIP"
SKIP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BRAN-(CW*(C_HOFFSET))
        DD    N_SKIP

BRAN1:  LODSD
        ADD     ESI,EAX
        JMP NEXT
;

;  ***************
;  *   0BRANCH   *
;  ***************
;
N_ZBRAN:   DD      7
        DB      "0BRANCH"
ZBRAN:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SKIP-(CW*(C_HOFFSET))
        DD    N_ZBRAN

        POP     EAX      ; GET STACK VALUE
        OR      EAX,EAX   ; ZERO?
        JZ      BRAN1   ; YES, BRANCH
        LEA     ESI,[ESI+(CW*(1))]
        JMP NEXT
;

;  **************
;  *   (LOOP)   *
;  **************
;
N_XLOOP:   DD      6
        DB      "(LOOP)"
XLOOP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ZBRAN-(CW*(C_HOFFSET))
        DD    N_XLOOP

        MOV     EBX,1    ; INCREMENT
XLOO1:  ADD     [EBP],EBX ; INDEX = INDEX + INCR
        MOV     EAX,[EBP] ; GET NEW INDEX
        SUB     EAX,[EBP+(CW*(1))]        ; COMPARE WITH LIMIT
        XOR     EAX,EBX   ; TEST SIGN
        JS      BRAN1   ; KEEP LOOPING
;
;  END OF `DO' LOOP
        LEA     EBP,[EBP+(CW*(3))]  ; ADJ RETURN STACK
        LEA     ESI,[ESI+(CW*(1))]       ; BYPASS BRANCH OFFSET
        JMP NEXT
;

;  ***************
;  *   (+LOOP)   *
;  ***************
;
N_XPLOO:   DD      7
        DB      "(+LOOP)"
XPLOO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    XLOOP-(CW*(C_HOFFSET))
        DD    N_XPLOO

        POP     EBX      ; GET LOOP VALUE
        JMP SHORT     XLOO1
;

;  ************
;  *   (DO)   *
;  ************
;
N_XDO:   DD      4
        DB      "(DO)"
XDO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    XPLOO-(CW*(C_HOFFSET))
        DD    N_XDO

        LODSD
        ADD     EAX,ESI  ;Make absolute
        POP     EDX      ; INITIAL INDEX VALUE
        POP     EBX      ; LIMIT VALUE
        XCHG    EBP,ESP   ; GET RETURN STACK
        PUSH    EAX      ; Target location.
        PUSH    EBX
        PUSH    EDX
        XCHG    EBP,ESP   ; GET PARAMETER STACK
        JMP NEXT
;

;  *************
;  *   (?DO)   *
;  *************
;
N_XQDO:   DD      5
        DB      "(?DO)"
XQDO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    XDO-(CW*(C_HOFFSET))
        DD    N_XQDO

        LODSD
        ADD     EAX,ESI  ;Make absolute
        POP     EDX      ; INITIAL INDEX VALUE
        POP     EBX      ; LIMIT VALUE
        CMP     EDX,EBX
        JZ      QXDO1
        XCHG    EBP,ESP   ; GET RETURN STACK
        PUSH    EAX      ; Target location.
        PUSH    EBX
        PUSH    EDX
        XCHG    EBP,ESP   ; GET PARAMETER STACK
        JMP NEXT
QXDO1:  MOV     ESI,EAX
        JMP NEXT
;

;  *********
;  *   I   *
;  *********
;
N_IDO:   DD      1
        DB      "I"
IDO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    XQDO-(CW*(C_HOFFSET))
        DD    N_IDO

        MOV     EAX,[EBP] ; GET INDEX VALUE
        PUSH    EAX
        JMP NEXT          ; TO PARAMETER STACK
;

;  *********
;  *   J   *
;  *********
;
N_JDO:   DD      1
        DB      "J"
JDO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    IDO-(CW*(C_HOFFSET))
        DD    N_JDO

        MOV     EAX,[EBP+(CW*(3))] ; GET INDEX VALUE
        PUSH    EAX
        JMP NEXT          ; TO PARAMETER STACK
;

;  **************
;  *   UNLOOP   *
;  **************
;
N_UNLOOP:   DD      6
        DB      "UNLOOP"
UNLOOP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    JDO-(CW*(C_HOFFSET))
        DD    N_UNLOOP

        DD      LIT, RDROP, COMMA
        DD      LIT, RDROP, COMMA
        DD      LIT, RDROP, COMMA
        DD      SEMIS
;

;  ***************
;  *   +ORIGIN   *
;  ***************
;
N_PORIG:   DD      7
        DB      "+ORIGIN"
PORIG:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    UNLOOP-(CW*(C_HOFFSET))
        DD    N_PORIG

        DD      LIT
        DD      USINI
        DD      PLUS
        DD      SEMIS
;
;      Initialisation block for user variables through DOC-LINK
;       <<<<< must be in same order as user variables >>>>>
;
;        DD      WARM_ENTRY FIXME
;        DD      COLD_ENTRY
USINI:  DD      STRUSA  ; User area currently in use, cold value same as next.
        DD      STRUSA  ; INIT (U0) user area of the main task 1
        DD      INITS0  ; INIT (S0)         2
        DD      INITR0  ; INIT (R0)         3
        DD      STRTIB  ; INIT (TIB)        4
        DD      BSIN    ; RUBOUT: get rid of latest char 5
        DD      0       ; AVAILABLE         6
        DD      1       ; INIT (WARNING)     7
        DD      INITDP  ;      INIT (FENCE)  8
        DD      INITDP  ;      INIT (DP)     9
        DD      ENV-(CW*(C_HOFFSET)) ;       INIT (VOC-LINK) 10

        DD      0       ; INIT (OFFSET) 
 ; 
;
;
;
;
;
;
        DD      0, 0            ; WHERE             12 13 
        DD      0, STRTIB       ;REMAINDER   14 15 
; 
        RESB    US-($ - USINI)        ; All user can be initialised.
;
;      <<<<< end of data used by cold start >>>>>

;  *************
;  *   DIGIT   *
;  *************
;
N_DIGIT:   DD      5
        DB      "DIGIT"
DIGIT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PORIG-(CW*(C_HOFFSET))
        DD    N_DIGIT

        POP     EDX      ;NUMBER BASE
        POP     EAX      ;ASCII DIGIT
        SUB     AL,'0'
        JB      DIGI2   ;NUMBER ERROR
        CMP     AL,9
        JBE     DIGI1   ;NUMBER = 0 THRU 9
        SUB     AL,7
        CMP     AL,10   ;NUMBER 'A' THRU 'Z'?
        JB      DIGI2   ;NO
DIGI1:  CMP     AL,DL   ; COMPARE NUMBER TO BASE
        JAE     DIGI2   ;NUMBER ERROR
        SUB     EDX,EDX   ;ZERO
        MOV     DL,AL   ;NEW BINARY NUMBER
        MOV     AL,1    ;TRUE FLAG
        PUSH    EDX
        PUSH    EAX
        JMP NEXT          ;ADD TO STACK
;   NUMBER ERROR
DIGI2:  SUB     EAX,EAX   ;FALSE FLAG
        PUSH    EAX
        JMP NEXT
;

;  **************
;  *   RESULT   *
;  **************
;
N_RESULT:   DD      6
        DB      "RESULT"
RESULT:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DIGIT-(CW*(C_HOFFSET))
        DD    N_RESULT

        DD 0
;

;  **********************
;  *   MATCHING-WORDS   *
;  **********************
;
N_MATCHING:   DD      14
        DB      "MATCHING-WORDS"
MATCHING:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RESULT-(CW*(C_HOFFSET))
        DD    N_MATCHING

        DD      TOR
        DD      RR, TFFA, FETCH
        DD      LIT, B_INVIS | B_DUMMY, LAND ;Get flags.
        DD      ZEQU
        DD      ZBRAN
        DD      MATS2-$-CW
;       DD      RR, IDDOT
        DD      RR, TNFA, FETCH, FETCH
        DD      OVER, LSUB
        DD      RR, TFFA, FETCH, LIT, B_DENOT, LAND ;Get flag.
        DD      OVER, ZLESS, LAND  ;Ignorable length difference.
        DD      ZEQU, LAND
        DD      ZEQU
        DD      ZBRAN
        DD      MATS2-$-CW
        DD      OVER
        DD      RR, TNFA, FETCH, SFET
        DD      CORA, ZEQU  ; Compare equals.
        DD      ZBRAN
        DD      MATS2-$-CW
        DD      FROMR, FROMR
        DD      RDROP, ZERO, TOR ;FORCE END
        DD      TOR, TOR
        DD      RR, RESULT, STORE
MATS2:  DD      RDROP
        DD      SEMIS
;

;  **************
;  *   ?BLANK   *
;  **************
;
N_QBL:   DD      6
        DB      "?BLANK"
QBL:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MATCHING-(CW*(C_HOFFSET))
        DD    N_QBL

        DD      LBL, ONEP, LESS
        DD      SEMIS
;

;  ************
;  *   IN[]   *
;  ************
;
N_INBRS:   DD      4
        DB      "IN[]"
INBRS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QBL-(CW*(C_HOFFSET))
        DD    N_INBRS

        DD      SRC, CELLP, TFET
        DD      OVER, EQUAL
        DD      ZBRAN
        DD      INBRS1-$-CW
        DD      ZERO
        DD      BRAN
        DD      INBRS2-$-CW
INBRS1:
        DD      LDUP
        
        DD      CFET
        DD      ONE, LIN, PSTORE
INBRS2:
        DD      SEMIS
;

;  **************
;  *   (WORD)   *
;  **************
;
N_LPWORD:   DD      6
        DB      "(WORD)"
LPWORD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    INBRS-(CW*(C_HOFFSET))
        DD    N_LPWORD

        DD      X
PWORD0: DD      DROP
        DD      INBRS, QBL
        DD      OVER, SRC, CELLP, FETCH, LSUB ; At end?
        DD      LAND, ZEQU
        DD      ZBRAN
        DD      PWORD0-$-CW

        DD      X
PWORD1: DD      DROP
        DD      INBRS, QBL
        DD      ZBRAN
        DD      PWORD1-$-CW

        DD      OVER, LSUB
        
        DD      SEMIS
;

;  ***************
;  *   (PARSE)   *
;  ***************
;
N_PPARS:   DD      7
        DB      "(PARSE)"
PPARS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LPWORD-(CW*(C_HOFFSET))
        DD    N_PPARS

        DD      SRC, CELLP, TFET
        DD      OVER, LSUB
        
        DD      ROT, SSPLIT, TSWAP
        DD      ZEQU
        DD      ZBRAN
        DD      PPARS8-$-CW
        DD      DROP, SRC, CELLP, FETCH
PPARS8: 
        DD      LIN, STORE
        DD SEMIS
;

;  ***********
;  *   SRC   *
;  ***********
;
N_SRC:   DD      3
        DB      "SRC"
SRC:        DD    DOUSE
        DD    (CW*(27))
        DD    0H
        DD    PPARS-(CW*(C_HOFFSET))
        DD    N_SRC
      ; And 28 and 29.
;


;  **************
;  *   SOURCE   *
;  **************
;
N_SOURCE:   DD      6
        DB      "SOURCE"
SOURCE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SRC-(CW*(C_HOFFSET))
        DD    N_SOURCE

        DD      SRC, FETCH
        DD      SRC, CELLP, FETCH
        DD      OVER, LSUB
        DD      SEMIS
;

;  ***********
;  *   >IN   *
;  ***********
;
N_IIN:   DD      3
        DB      ">IN"
IIN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SOURCE-(CW*(C_HOFFSET))
        DD    N_IIN

        DD      LIN, FETCH
DD      SRC, FETCH, LSUB     
        DD      PIIN, STORE
        DD      PIIN
        DD      SEMIS
;
;

;  **********
;  *   CR   *
;  **********
;
N_CR:   DD      2
        DB      "CR"
CR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    IIN-(CW*(C_HOFFSET))
        DD    N_CR

        DD      LIT,ALF
        DD      EMIT
        DD      ZERO, LOUT, STORE
        DD      SEMIS
;

;  *************
;  *   CMOVE   *
;  *************
;
N_LCMOVE:   DD      5
        DB      "CMOVE"
LCMOVE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CR-(CW*(C_HOFFSET))
        DD    N_LCMOVE

        CLD             ;direction
        MOV     EBX,ESI   ;save 
        POP     ECX      ;count
        POP     EDI      ;dest
        POP     ESI      ;source
        REP     MOVSB
        MOV     ESI,EBX   ;get back 
        JMP NEXT
;

;  ************
;  *   MOVE   *
;  ************
;
N_LMOVE:   DD      4
        DB      "MOVE"
LMOVE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LCMOVE-(CW*(C_HOFFSET))
        DD    N_LMOVE

        MOV     EBX,ESI   ;SAVE 
        POP     ECX      ;count
        POP     EDI      ;dest
        POP     ESI      ;source
        CMP     ESI,EDI
        JC    MOVE1
        CLD             ;INC DIRECTION
        JMP SHORT MOVE2
MOVE1:  STD
        ADD     EDI,ECX
        DEC     EDI
        ADD     ESI,ECX
        DEC     ESI
MOVE2:
        REP     MOVSB   ;THAT'S THE MOVE
        CLD             ;INC DIRECTION
        MOV     ESI,EBX   ;GET BACK 
        JMP NEXT
;

;  ***************
;  *   FARMOVE   *
;  ***************
;
N_FMOVE:   DD      7
        DB      "FARMOVE"
FMOVE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LMOVE-(CW*(C_HOFFSET))
        DD    N_FMOVE

        CLD             ;direction
        MOV     EAX,ESI   ;save 
        MOV     EBX,DS    ;save 
        POP     ECX      ;count
        POP     EDI      ;dest
        POP     EDX
        AND     EDX,EDX
        JZ      FARMV1
        MOV     ES,EDX
FARMV1:
        POP     ESI      ;source
        POP     EDX
        PUSH    DS
        PUSH    EBX      ;ES in fact.
        AND     EDX,EDX
        JZ      FARMV2
        MOV     DS,EDX
FARMV2:
        REP     MOVSB
        MOV     ESI,EAX   ;restore 
        POP     ES
        POP     DS
        JMP NEXT
;

;  ***********
;  *   UM*   *
;  ***********
;
N_USTAR:   DD      3
        DB      "UM*"
USTAR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FMOVE-(CW*(C_HOFFSET))
        DD    N_USTAR

        POP     EAX
        POP     EBX
        MUL     EBX      ;UNSIGNED
        XCHG    EAX,EDX   ;AX NOW = MSW
        PUSH    EDX
        PUSH    EAX
        JMP NEXT          ;STORE DOUBLE CELL
;

;  **************
;  *   UM/MOD   *
;  **************
;
N_USLAS:   DD      6
        DB      "UM/MOD"
USLAS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    USTAR-(CW*(C_HOFFSET))
        DD    N_USLAS

        POP     EBX      ;DIVISOR
        POP     EDX      ;MSW OF DIVIDEND
        POP     EAX      ;LSW OF DIVIDEND
        DIV     EBX      ;16 BIT DIVIDE
        PUSH    EDX
        PUSH    EAX
        JMP NEXT          ;STORE QUOT/REM
;

;  ***********
;  *   AND   *
;  ***********
;
N_LAND:   DD      3
        DB      "AND"
LAND:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    USLAS-(CW*(C_HOFFSET))
        DD    N_LAND

        POP     EAX
        POP     EBX
        AND     EAX,EBX
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   OR   *
;  **********
;
N_LOR:   DD      2
        DB      "OR"
LOR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LAND-(CW*(C_HOFFSET))
        DD    N_LOR

        POP     EAX      ; (S1) <- (S1) OR (S2)
        POP     EBX
        OR      EAX,EBX
        PUSH    EAX
        JMP NEXT
;

;  ***********
;  *   XOR   *
;  ***********
;
N_LXOR:   DD      3
        DB      "XOR"
LXOR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LOR-(CW*(C_HOFFSET))
        DD    N_LXOR

        POP     EAX      ; (S1) <- (S1) XOR (S2)
        POP     EBX
        XOR     EAX,EBX
        PUSH    EAX
        JMP NEXT
;

;  **************
;  *   INVERT   *
;  **************
;
N_INVERT:   DD      6
        DB      "INVERT"
INVERT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LXOR-(CW*(C_HOFFSET))
        DD    N_INVERT

        POP     EAX      ; (S1) <- (S1) XOR (S2)
        NOT     EAX
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   DSP@   *
;  ************
;
N_SPFET:   DD      4
        DB      "DSP@"
SPFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    INVERT-(CW*(C_HOFFSET))
        DD    N_SPFET

        MOV     EAX,ESP   ; (S1) <- (SP)
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   DSP!   *
;  ************
;
N_SPSTO:   DD      4
        DB      "DSP!"
SPSTO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SPFET-(CW*(C_HOFFSET))
        DD    N_SPSTO

        POP     EAX
        MOV     ESP,EAX        ;RESET PARAM STACK POINTER
        JMP NEXT
;


;  *************
;  *   DEPTH   *
;  *************
;
N_DEPTH:   DD      5
        DB      "DEPTH"
DEPTH:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SPSTO-(CW*(C_HOFFSET))
        DD    N_DEPTH

        DD      SZERO, FETCH
        DD      SPFET
        DD      LSUB
        DD      LIT, CW, SLASH
        DD      ONEM
        DD      SEMIS
;
;

;  ************
;  *   RSP@   *
;  ************
;
N_RPFET:   DD      4
        DB      "RSP@"
RPFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DEPTH-(CW*(C_HOFFSET))
        DD    N_RPFET
      ;(S1) <- (RP)
        PUSH    EBP
        JMP NEXT
;

;  ************
;  *   RSP!   *
;  ************
;
N_RPSTO:   DD      4
        DB      "RSP!"
RPSTO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RPFET-(CW*(C_HOFFSET))
        DD    N_RPSTO

        POP     EBP
        JMP NEXT
;

;  ************
;  *   EXIT   *
;  ************
;
N_EXIT:   DD      4
        DB      "EXIT"
EXIT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RPSTO-(CW*(C_HOFFSET))
        DD    N_EXIT

        MOV     ESI,[EBP] ;(IP) <- (R1)
        LEA     EBP,[EBP+(CW*(1))]
        JMP NEXT
;

;  ***********
;  *   (;)   *
;  ***********
;
N_SEMIS:   DD      3
        DB      "(;)"
SEMIS:        DD    (EXIT+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    EXIT-(CW*(C_HOFFSET))
        DD    N_SEMIS

;

;  *************
;  *   LEAVE   *
;  *************
;
N_LLEAV:   DD      5
        DB      "LEAVE"
LLEAV:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SEMIS-(CW*(C_HOFFSET))
        DD    N_LLEAV
  ;LIMIT <- INDEX
        DD      RDROP, RDROP, RDROP
        DD      SEMIS
;

;  **********
;  *   >R   *
;  **********
;
N_TOR:   DD      2
        DB      ">R"
TOR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LLEAV-(CW*(C_HOFFSET))
        DD    N_TOR
        ; (R1) <- (S1)
        POP     EBX      ;GET STACK PARAMETER
        LEA     EBP,[EBP - (CW*(1))]    ;MOVE RETURN STACK DOWN
        MOV     [EBP],EBX ;ADD TO RETURN STACK
        JMP NEXT
;

;  **********
;  *   R>   *
;  **********
;
N_FROMR:   DD      2
        DB      "R>"
FROMR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TOR-(CW*(C_HOFFSET))
        DD    N_FROMR
      ;(S1) <- (R1)
        MOV     EAX,[EBP] ; GET RETURN STACK VALUE
        LEA     EBP,[EBP + (CW*(1))]
        PUSH    EAX
        JMP NEXT
;

;  *************
;  *   RDROP   *
;  *************
;
N_RDROP:   DD      5
        DB      "RDROP"
RDROP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FROMR-(CW*(C_HOFFSET))
        DD    N_RDROP
      ;(S1) <- (R1)
        LEA     EBP,[EBP+(CW*(1))]
        JMP NEXT
;

;  **********
;  *   R@   *
;  **********
;
N_RR:   DD      2
        DB      "R@"
RR:        DD    (IDO+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RDROP-(CW*(C_HOFFSET))
        DD    N_RR

;

;  **********
;  *   0=   *
;  **********
;
N_ZEQU:   DD      2
        DB      "0="
ZEQU:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RR-(CW*(C_HOFFSET))
        DD    N_ZEQU

        POP     EAX
        NEG     EAX
        CMC
        SBB     EAX,EAX
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   0<   *
;  **********
;
N_ZLESS:   DD      2
        DB      "0<"
ZLESS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ZEQU-(CW*(C_HOFFSET))
        DD    N_ZLESS

        POP     EAX
        OR      EAX,EAX   ;SET FLAGS
        MOV     EAX,0    ;FALSE
        JNS     ZLESS1
        DEC     EAX      ;TRUE
ZLESS1: PUSH    EAX
        JMP NEXT
;

;  *********
;  *   +   *
;  *********
;
N_PLUS:   DD      1
        DB      "+"
PLUS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ZLESS-(CW*(C_HOFFSET))
        DD    N_PLUS

        POP     EAX      ;(S1) <- (S1) + (S2)
        POP     EBX
        ADD     EAX,EBX
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   D+   *
;  **********
;
N_DPLUS:   DD      2
        DB      "D+"
DPLUS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PLUS-(CW*(C_HOFFSET))
        DD    N_DPLUS

        POP     EAX      ; YHW
        POP     EDX      ; YLW
        POP     EBX      ; XHW
        POP     ECX      ; XLW
        ADD     EDX,ECX   ; SLW
        ADC     EAX,EBX   ; SHW
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  **************
;  *   NEGATE   *
;  **************
;
N_NEGATE:   DD      6
        DB      "NEGATE"
NEGATE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DPLUS-(CW*(C_HOFFSET))
        DD    N_NEGATE

        POP     EAX
        NEG     EAX
        PUSH    EAX
        JMP NEXT
;

;  ***************
;  *   DNEGATE   *
;  ***************
;
N_DNEGA:   DD      7
        DB      "DNEGATE"
DNEGA:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    NEGATE-(CW*(C_HOFFSET))
        DD    N_DNEGA

        POP     EBX
        POP     ECX
        SUB     EAX,EAX
        MOV     EDX,EAX
        SUB     EDX,ECX   ; MAKE 2'S COMPLEMENT
        SBB     EAX,EBX   ; HIGH CELL
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
        ;
;

;  ************
;  *   OVER   *
;  ************
;
N_OVER:   DD      4
        DB      "OVER"
OVER:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DNEGA-(CW*(C_HOFFSET))
        DD    N_OVER

        POP     EDX
        POP     EAX
        PUSH    EAX
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   DROP   *
;  ************
;
N_DROP:   DD      4
        DB      "DROP"
DROP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    OVER-(CW*(C_HOFFSET))
        DD    N_DROP

        POP     EAX
        JMP NEXT
;

;  *************
;  *   2DROP   *
;  *************
;
N_TDROP:   DD      5
        DB      "2DROP"
TDROP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DROP-(CW*(C_HOFFSET))
        DD    N_TDROP

        POP     EAX
        POP     EAX
        JMP NEXT
;

;  ************
;  *   SWAP   *
;  ************
;
N_SWAP:   DD      4
        DB      "SWAP"
SWAP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TDROP-(CW*(C_HOFFSET))
        DD    N_SWAP

        POP     EDX
        POP     EAX
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  ***********
;  *   DUP   *
;  ***********
;
N_LDUP:   DD      3
        DB      "DUP"
LDUP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SWAP-(CW*(C_HOFFSET))
        DD    N_LDUP

        POP     EAX
        PUSH    EAX
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   2DUP   *
;  ************
;
N_TDUP:   DD      4
        DB      "2DUP"
TDUP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LDUP-(CW*(C_HOFFSET))
        DD    N_TDUP

        POP     EAX
        POP     EDX
        PUSH    EDX
        PUSH    EAX
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  *************
;  *   2SWAP   *
;  *************
;
N_TSWAP:   DD      5
        DB      "2SWAP"
TSWAP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TDUP-(CW*(C_HOFFSET))
        DD    N_TSWAP

        POP     EBX
        POP     ECX
        POP     EAX
        POP     EDX
        PUSH     ECX
        PUSH     EBX
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  *************
;  *   2OVER   *
;  *************
;
N_TOVER:   DD      5
        DB      "2OVER"
TOVER:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TSWAP-(CW*(C_HOFFSET))
        DD    N_TOVER

        POP     EBX
        POP     ECX
        POP     EAX
        POP     EDX
        PUSH     EDX
        PUSH     EAX
        PUSH     ECX
        PUSH     EBX
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   +!   *
;  **********
;
N_PSTORE:   DD      2
        DB      "+!"
PSTORE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TOVER-(CW*(C_HOFFSET))
        DD    N_PSTORE

        POP     EBX      ;ADDRESS
        POP     EAX      ;INCREMENT
        ADD     [EBX],EAX
        JMP NEXT
;

;  **************
;  *   TOGGLE   *
;  **************
;
N_TOGGL:   DD      6
        DB      "TOGGLE"
TOGGL:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PSTORE-(CW*(C_HOFFSET))
        DD    N_TOGGL

        POP     EAX      ;BIT PATTERN
        POP     EBX      ;ADDR
        XOR     [EBX],EAX ;
        JMP NEXT
;

;  *********
;  *   @   *
;  *********
;
N_FETCH:   DD      1
        DB      "@"
FETCH:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TOGGL-(CW*(C_HOFFSET))
        DD    N_FETCH

        POP     EBX
        MOV     EAX,[EBX]
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   C@   *
;  **********
;
N_CFET:   DD      2
        DB      "C@"
CFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FETCH-(CW*(C_HOFFSET))
        DD    N_CFET

        POP     EBX
        XOR     EAX,EAX
        MOV     AL,[EBX]
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   2@   *
;  **********
;
N_TFET:   DD      2
        DB      "2@"
TFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CFET-(CW*(C_HOFFSET))
        DD    N_TFET

        POP     EBX      ;ADDR
        MOV     EAX,[EBX] ;MSW
        MOV     EDX,[EBX+(CW*(1))]        ;LSW
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  *********
;  *   !   *
;  *********
;
N_STORE:   DD      1
        DB      "!"
STORE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TFET-(CW*(C_HOFFSET))
        DD    N_STORE

        POP     EBX      ;ADDR
        POP     EAX      ;DATA
        MOV     [EBX],EAX
        JMP NEXT
;

;  **********
;  *   C!   *
;  **********
;
N_CSTOR:   DD      2
        DB      "C!"
CSTOR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    STORE-(CW*(C_HOFFSET))
        DD    N_CSTOR

        POP     EBX      ;ADDR
        POP     EAX      ;DATA
        MOV     [EBX],AL
        JMP NEXT
;

;  **********
;  *   2!   *
;  **********
;
N_TSTOR:   DD      2
        DB      "2!"
TSTOR:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CSTOR-(CW*(C_HOFFSET))
        DD    N_TSTOR

        POP     EBX      ;ADDR
        POP     EAX      ;MSW
        MOV     [EBX],EAX
        POP     EAX      ;LSW
        MOV     [EBX+(CW*(1))],EAX
        JMP NEXT
;

;  **************
;  *   WITHIN   *
;  **************
;
N_WITHIN:   DD      6
        DB      "WITHIN"
WITHIN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TSTOR-(CW*(C_HOFFSET))
        DD    N_WITHIN

        DD      OVER, LSUB, TOR
        DD      LSUB, FROMR
        DD      ULESS
        DD      SEMIS
;


;  **********
;  *   L@   *
;  **********
;
N_LFET:   DD      2
        DB      "L@"
LFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    WITHIN-(CW*(C_HOFFSET))
        DD    N_LFET

        POP     EBX      ;MEM LOC
        POP     ECX      ;SEG REG VAL
        MOV     EDX,DS   ; Leave this for real mode code.
        MOV     DS,ECX
        MOV     EBX,[EBX]
        MOV     DS,EDX
        PUSH    EBX
        JMP NEXT
;

;  **********
;  *   L!   *
;  **********
;
N_LSTORE:   DD      2
        DB      "L!"
LSTORE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LFET-(CW*(C_HOFFSET))
        DD    N_LSTORE

        POP     EBX
        POP     ECX
        POP     EDX
        MOV     EAX,DS
        MOV     DS,ECX
        MOV     [EBX],EDX
        MOV     DS,EAX
        JMP NEXT
;
;

;  *********
;  *   :   *
;  *********
;
N_COLON:   DD      1
        DB      ":"
COLON:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LSTORE-(CW*(C_HOFFSET))
        DD    N_COLON

        DD      SCSP
        DD      LPWORD
        DD      PCREAT
        DD      LATEST, HIDDEN
        DD      RBRAC
        DD      PSCOD
DOCOL:  LEA     EBP,[EBP - (CW*(1))]
        MOV     [EBP],ESI ;R1 <- (IP)
         MOV     ESI,[EAX+(CW*(D_HOFFSET - C_HOFFSET))]  ;(IP) <- (PFA)
;        CALL    DISPLAYSI
; 
        JMP NEXT
;

;  *********
;  *   ;   *
;  *********
;
N_SEMI:   DD      1
        DB      ";"
SEMI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    COLON-(CW*(C_HOFFSET))
        DD    N_SEMI

        DD      QCSP
        DD      LIT, SEMIS, COMMA
        DD      LATEST, HIDDEN
        DD      LBRAC
        DD      SEMIS
;

;  ****************
;  *   CONSTANT   *
;  ****************
;
N_LCONST:   DD      8
        DB      "CONSTANT"
LCONST:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SEMI-(CW*(C_HOFFSET))
        DD    N_LCONST

        DD      LPWORD
        DD      PCREAT
        DD      LATEST, TDFA, STORE
        DD      PSCOD
DOCON:  MOV     EAX,[EAX+(CW*((D_HOFFSET-C_HOFFSET)))] ;GET DATA FROM PFA
        PUSH    EAX
        JMP NEXT
;

;  ****************
;  *   VARIABLE   *
;  ****************
;
N_VAR:   DD      8
        DB      "VARIABLE"
VAR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LCONST-(CW*(C_HOFFSET))
        DD    N_VAR

        DD      LPWORD
        DD      PCREAT
        DD      ZERO, COMMA
        DD      PSCOD
DOVAR:  MOV     EAX,[EAX+(CW*((D_HOFFSET-C_HOFFSET)))] ;(AX) <- PFA
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   USER   *
;  ************
;
N_USER:   DD      4
        DB      "USER"
USER:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    VAR-(CW*(C_HOFFSET))
        DD    N_USER

        DD      LCONST
        DD      PSCOD
DOUSE:  MOV     EBX,[EAX+(CW*((D_HOFFSET-C_HOFFSET)))] ;PFA  
        MOV     EDI, LONG[USINI]
        LEA     EAX,[EBX+EDI]      ;ADDR OF VARIABLE
        PUSH    EAX
        JMP NEXT
;
;

;  *********
;  *   _   *
;  *********
;
N_X:   DD      1
        DB      "_"
X:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    USER-(CW*(C_HOFFSET))
        DD    N_X

        PUSH    EAX
        JMP NEXT ;Whatever happens to be in EAX, i.e. the dea of ``_''.
;

;  *********
;  *   0   *
;  *********
;
N_ZERO:   DD      1
        DB      "0"
ZERO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    X-(CW*(C_HOFFSET))
        DD    N_ZERO

        XOR     EAX,EAX
        PUSH    EAX
        JMP NEXT
;

;  *********
;  *   1   *
;  *********
;
N_ONE:   DD      1
        DB      "1"
ONE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ZERO-(CW*(C_HOFFSET))
        DD    N_ONE

        MOV     EAX,1
        PUSH    EAX
        JMP NEXT
;

;  *********
;  *   2   *
;  *********
;
N_TWO:   DD      1
        DB      "2"
TWO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ONE-(CW*(C_HOFFSET))
        DD    N_TWO

        MOV     EAX,2
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   BL   *
;  **********
;
N_LBL:   DD      2
        DB      "BL"
LBL:        DD    DOCON
        DD    ABL
        DD    0H
        DD    TWO-(CW*(C_HOFFSET))
        DD    N_LBL

;

;  **********
;  *   $@   *
;  **********
;
N_SFET:   DD      2
        DB      "$@"
SFET:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LBL-(CW*(C_HOFFSET))
        DD    N_SFET

        DD LDUP, CELLP, SWAP, FETCH
        DD SEMIS
;

;  **********
;  *   $!   *
;  **********
;
N_SSTOR:   DD      2
        DB      "$!"
SSTOR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SFET-(CW*(C_HOFFSET))
        DD    N_SSTOR

        DD TDUP, STORE, CELLP, SWAP, LCMOVE
        DD SEMIS
;

;  *************
;  *   $!-BD   *
;  *************
;
N_SSTORBD:   DD      5
        DB      "$!-BD"
SSTORBD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SSTOR-(CW*(C_HOFFSET))
        DD    N_SSTORBD

        DD TDUP, CSTOR, ONEP, SWAP, LCMOVE
        DD SEMIS
;

;  ***********
;  *   $+!   *
;  ***********
;
N_SADD:   DD      3
        DB      "$+!"
SADD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SSTORBD-(CW*(C_HOFFSET))
        DD    N_SADD

        DD   LDUP, FETCH, TOR ; Remember old count.
        DD   TDUP, PSTORE
        DD   CELLP, FROMR, PLUS, SWAP, LCMOVE
        DD SEMIS
;

;  ***********
;  *   $C+   *
;  ***********
;
N_CHAPP:   DD      3
        DB      "$C+"
CHAPP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SADD-(CW*(C_HOFFSET))
        DD    N_CHAPP

        DD   LDUP, TOR
        DD   LDUP, FETCH, PLUS, CELLP, CSTOR
        DD   ONE, FROMR, PSTORE
        DD SEMIS
;

;  **********
;  *   $,   *
;  **********
;
N_SCOMMA:   DD      2
        DB      "$,"
SCOMMA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CHAPP-(CW*(C_HOFFSET))
        DD    N_SCOMMA

        DD HERE, TOR
        DD LDUP, CELLP, ALLOT
        DD RR, SSTOR, FROMR
        DD SEMIS
;

;  ***********
;  *   C/L   *
;  ***********
;
N_CSLL:   DD      3
        DB      "C/L"
CSLL:        DD    DOCON
        DD    64
        DD    0H
        DD    SCOMMA-(CW*(C_HOFFSET))
        DD    N_CSLL

;


;  *************
;  *   FIRST   *
;  *************
;
N_FIRST:   DD      5
        DB      "FIRST"
FIRST:        DD    DOCON
        DD    BUF1
        DD    0H
        DD    CSLL-(CW*(C_HOFFSET))
        DD    N_FIRST

 ;  
;
; 
;

;  *************
;  *   LIMIT   *
;  *************
;
N_LIMIT:   DD      5
        DB      "LIMIT"
LIMIT:        DD    DOCON
        DD    BUF1+(KBBUF+2*CW)*NBUF
        DD    0H
        DD    FIRST-(CW*(C_HOFFSET))
        DD    N_LIMIT

; THE END  OF THE MEMORY 

;  **********
;  *   EM   *
;  **********
;
N_LEM:   DD      2
        DB      "EM"
LEM:        DD    DOCON
        DD    ACTUAL_EM
        DD    0H
        DD    LIMIT-(CW*(C_HOFFSET))
        DD    N_LEM

;

;  **********
;  *   BM   *
;  **********
;
N_LBM:   DD      2
        DB      "BM"
LBM:        DD    DOCON
        DD    ORG0
        DD    0H
        DD    LEM-(CW*(C_HOFFSET))
        DD    N_LBM

;

;  *************
;  *   B/BUF   *
;  *************
;
N_BBUF:   DD      5
        DB      "B/BUF"
BBUF:        DD    DOCON
        DD    KBBUF
        DD    0H
        DD    LBM-(CW*(C_HOFFSET))
        DD    N_BBUF

;
; All user variables are initialised 
; with the values from USINI.
; The implementation relies on the initialisation of 
; those with numbers (1..11), so change in concord with USINI.

;  **********
;  *   U0   *
;  **********
;
N_UZERO:   DD      2
        DB      "U0"
UZERO:        DD    DOUSE
        DD    (CW*(1))
        DD    0H
        DD    BBUF-(CW*(C_HOFFSET))
        DD    N_UZERO

;

;  **********
;  *   S0   *
;  **********
;
N_SZERO:   DD      2
        DB      "S0"
SZERO:        DD    DOUSE
        DD    (CW*(2))
        DD    0H
        DD    UZERO-(CW*(C_HOFFSET))
        DD    N_SZERO

;

;  **********
;  *   R0   *
;  **********
;
N_RZERO:   DD      2
        DB      "R0"
RZERO:        DD    DOUSE
        DD    (CW*(3))
        DD    0H
        DD    SZERO-(CW*(C_HOFFSET))
        DD    N_RZERO

;

;  ***********
;  *   TIB   *
;  ***********
;
N_TIB:   DD      3
        DB      "TIB"
TIB:        DD    DOUSE
        DD    (CW*(4))
        DD    0H
        DD    RZERO-(CW*(C_HOFFSET))
        DD    N_TIB

;

;  **************
;  *   RUBOUT   *
;  **************
;
N_RUBOUT:   DD      6
        DB      "RUBOUT"
RUBOUT:        DD    DOUSE
        DD    (CW*(5))
        DD    0H
        DD    TIB-(CW*(C_HOFFSET))
        DD    N_RUBOUT

;

;  ***************
;  *   WARNING   *
;  ***************
;
N_LWARN:   DD      7
        DB      "WARNING"
LWARN:        DD    DOUSE
        DD    (CW*(7))
        DD    0H
        DD    RUBOUT-(CW*(C_HOFFSET))
        DD    N_LWARN

;

;  *************
;  *   FENCE   *
;  *************
;
N_FENCE:   DD      5
        DB      "FENCE"
FENCE:        DD    DOUSE
        DD    (CW*(8))
        DD    0H
        DD    LWARN-(CW*(C_HOFFSET))
        DD    N_FENCE

;

;  **********
;  *   DP   *
;  **********
;
N_LDP:   DD      2
        DB      "DP"
LDP:        DD    DOUSE
        DD    (CW*(9))
        DD    0H
        DD    FENCE-(CW*(C_HOFFSET))
        DD    N_LDP

;

;  ****************
;  *   VOC-LINK   *
;  ****************
;
N_VOCL:   DD      8
        DB      "VOC-LINK"
VOCL:        DD    DOUSE
        DD    (CW*(10))
        DD    0H
        DD    LDP-(CW*(C_HOFFSET))
        DD    N_VOCL

;

;  **************
;  *   OFFSET   *
;  **************
;
N_LOFFSET:   DD      6
        DB      "OFFSET"
LOFFSET:        DD    DOUSE
        DD    (CW*(11))
        DD    0H
        DD    VOCL-(CW*(C_HOFFSET))
        DD    N_LOFFSET

;
; End of user variables with fixed place.
;
;

;  *************
;  *   WHERE   *
;  *************
;
N_LWHERE:   DD      5
        DB      "WHERE"
LWHERE:        DD    DOUSE
        DD    (CW*(12))
        DD    0H
        DD    LOFFSET-(CW*(C_HOFFSET))
        DD    N_LWHERE
    ;  Occupies two CELLS! 
;

;  ***********
;  *   SCR   *
;  ***********
;
N_SCR:   DD      3
        DB      "SCR"
SCR:        DD    DOUSE
        DD    (CW*(33))
        DD    0H
        DD    LWHERE-(CW*(C_HOFFSET))
        DD    N_SCR

;

;  *************
;  *   STATE   *
;  *************
;
N_STATE:   DD      5
        DB      "STATE"
STATE:        DD    DOUSE
        DD    (CW*(18))
        DD    0H
        DD    SCR-(CW*(C_HOFFSET))
        DD    N_STATE

;

;  ************
;  *   BASE   *
;  ************
;
N_BASE:   DD      4
        DB      "BASE"
BASE:        DD    DOUSE
        DD    (CW*(19))
        DD    0H
        DD    STATE-(CW*(C_HOFFSET))
        DD    N_BASE

;

;  ***********
;  *   DPL   *
;  ***********
;
N_DPL:   DD      3
        DB      "DPL"
DPL:        DD    DOUSE
        DD    (CW*(20))
        DD    0H
        DD    BASE-(CW*(C_HOFFSET))
        DD    N_DPL

;

;  ***********
;  *   FLD   *
;  ***********
;
N_LFLD:   DD      3
        DB      "FLD"
LFLD:        DD    DOUSE
        DD    (CW*(21))
        DD    0H
        DD    DPL-(CW*(C_HOFFSET))
        DD    N_LFLD

;


;  ***********
;  *   CSP   *
;  ***********
;
N_LCSP:   DD      3
        DB      "CSP"
LCSP:        DD    DOUSE
        DD    (CW*(22))
        DD    0H
        DD    LFLD-(CW*(C_HOFFSET))
        DD    N_LCSP

;
;

;  **********
;  *   R#   *
;  **********
;
N_RNUM:   DD      2
        DB      "R#"
RNUM:        DD    DOUSE
        DD    (CW*(23))
        DD    0H
        DD    LCSP-(CW*(C_HOFFSET))
        DD    N_RNUM

;

;  ***********
;  *   HLD   *
;  ***********
;
N_HLD:   DD      3
        DB      "HLD"
HLD:        DD    DOUSE
        DD    (CW*(24))
        DD    0H
        DD    RNUM-(CW*(C_HOFFSET))
        DD    N_HLD

;

;  ***********
;  *   OUT   *
;  ***********
;
N_LOUT:   DD      3
        DB      "OUT"
LOUT:        DD    DOUSE
        DD    (CW*(25))
        DD    0H
        DD    HLD-(CW*(C_HOFFSET))
        DD    N_LOUT

;

;  *************
;  *   (BLK)   *
;  *************
;
N_PBLK:   DD      5
        DB      "(BLK)"
PBLK:        DD    DOUSE
        DD    (CW*(26))
        DD    0H
        DD    LOUT-(CW*(C_HOFFSET))
        DD    N_PBLK

;

;  **********
;  *   IN   *
;  **********
;
N_LIN:   DD      2
        DB      "IN"
LIN:        DD    DOUSE
        DD    (CW*(29))
        DD    0H
        DD    PBLK-(CW*(C_HOFFSET))
        DD    N_LIN

;


;  *************
;  *   (>IN)   *
;  *************
;
N_PIIN:   DD      5
        DB      "(>IN)"
PIIN:        DD    DOUSE
        DD    (CW*(30))
        DD    0H
        DD    LIN-(CW*(C_HOFFSET))
        DD    N_PIIN

;
;

;  ************
;  *   ARGS   *
;  ************
;
N_ARGS:   DD      4
        DB      "ARGS"
ARGS:        DD    DOUSE
        DD    (CW*(31))
        DD    0H
        DD    PIIN-(CW*(C_HOFFSET))
        DD    N_ARGS

;

;  ***************
;  *   HANDLER   *
;  ***************
;
N_HANDLER:   DD      7
        DB      "HANDLER"
HANDLER:        DD    DOUSE
        DD    (CW*(32))
        DD    0H
        DD    ARGS-(CW*(C_HOFFSET))
        DD    N_HANDLER

;

;  ***************
;  *   CURRENT   *
;  ***************
;
N_CURR:   DD      7
        DB      "CURRENT"
CURR:        DD    DOUSE
        DD    (CW*(34))
        DD    0H
        DD    HANDLER-(CW*(C_HOFFSET))
        DD    N_CURR

;

;  *****************
;  *   REMAINDER   *
;  *****************
;
N_REMAIND:   DD      9
        DB      "REMAINDER"
REMAIND:        DD    DOUSE
        DD    (CW*(14))
        DD    0H
        DD    CURR-(CW*(C_HOFFSET))
        DD    N_REMAIND

;      IMPORTANT
; REQUIRES ONE MORE CELL!
;

;  ********************
;  *   SEARCH-ORDER   *
;  ********************
;
N_SEARCH:   DD      12
        DB      "SEARCH-ORDER"
SEARCH:        DD    DOUSE
        DD    (CW*(37))
        DD    0H
        DD    REMAIND-(CW*(C_HOFFSET))
        DD    N_SEARCH
 ; Up to  37+8
;      IMPORTANT
;     8 USER SPACE CELLS MUST BE KEPT FREE
;     IN ADDITION TO THE ONE FOR SEARCH
;
;========== END USER VARIABLES =============;
;

;  **********
;  *   1+   *
;  **********
;
N_ONEP:   DD      2
        DB      "1+"
ONEP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SEARCH-(CW*(C_HOFFSET))
        DD    N_ONEP

        POP     EAX
        INC     EAX
        PUSH    EAX
        JMP NEXT
;

;  *************
;  *   CELL+   *
;  *************
;
N_CELLP:   DD      5
        DB      "CELL+"
CELLP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ONEP-(CW*(C_HOFFSET))
        DD    N_CELLP

        POP     EAX
        ADD     EAX,CW
        PUSH    EAX
        JMP NEXT
;

;
;  *************
;  *   CELLS   *
;  *************
;
N_LCELLS:   DD      5
        DB      "CELLS"
LCELLS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CELLP-(CW*(C_HOFFSET))
        DD    N_LCELLS

        POP     EAX
        SHL     EAX,1
        SHL     EAX,1
        PUSH    EAX
        JMP NEXT
;

;  *************
;  *   CHAR+   *
;  *************
;
N_CHARP:   DD      5
        DB      "CHAR+"
CHARP:        DD    (ONEP+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LCELLS-(CW*(C_HOFFSET))
        DD    N_CHARP

;

;  *************
;  *   CHARS   *
;  *************
;
N_CHARS:   DD      5
        DB      "CHARS"
CHARS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    CHARP-(CW*(C_HOFFSET))
        DD    N_CHARS

        DD      SEMIS
;

;  *************
;  *   ALIGN   *
;  *************
;
N_LALIGN:   DD      5
        DB      "ALIGN"
LALIGN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    CHARS-(CW*(C_HOFFSET))
        DD    N_LALIGN

        DD      SEMIS
;

;  ***************
;  *   ALIGNED   *
;  ***************
;
N_ALIGNED:   DD      7
        DB      "ALIGNED"
ALIGNED:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LALIGN-(CW*(C_HOFFSET))
        DD    N_ALIGNED

        JMP NEXT
;

;  ************
;  *   HERE   *
;  ************
;
N_HERE:   DD      4
        DB      "HERE"
HERE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ALIGNED-(CW*(C_HOFFSET))
        DD    N_HERE

        DD      LDP
        DD      FETCH
        DD      SEMIS
;

;  *************
;  *   ALLOT   *
;  *************
;
N_ALLOT:   DD      5
        DB      "ALLOT"
ALLOT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    HERE-(CW*(C_HOFFSET))
        DD    N_ALLOT

        DD      LDP
        DD      PSTORE
        DD      SEMIS
;

;  *********
;  *   ,   *
;  *********
;
N_COMMA:   DD      1
        DB      ","
COMMA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ALLOT-(CW*(C_HOFFSET))
        DD    N_COMMA

        DD      HERE
        DD      STORE
        DD      LIT, CW
        DD      ALLOT
        DD      SEMIS
;

;  **********
;  *   C,   *
;  **********
;
N_CCOMM:   DD      2
        DB      "C,"
CCOMM:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    COMMA-(CW*(C_HOFFSET))
        DD    N_CCOMM

        DD      HERE
        DD      CSTOR
        DD      ONE
        DD      ALLOT
        DD      SEMIS
;

;  *********
;  *   -   *
;  *********
;
N_LSUB:   DD      1
        DB      "-"
LSUB:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CCOMM-(CW*(C_HOFFSET))
        DD    N_LSUB

        POP     EDX      ;S1
        POP     EAX
        SUB     EAX,EDX
        PUSH    EAX
        JMP NEXT   ;S1 = S2 - S1
;

;  *********
;  *   =   *
;  *********
;
N_EQUAL:   DD      1
        DB      "="
EQUAL:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LSUB-(CW*(C_HOFFSET))
        DD    N_EQUAL

        DD      LSUB
        DD      ZEQU
        DD      SEMIS
;

;  *********
;  *   <   *
;  *********
;
N_LESS:   DD      1
        DB      "<"
LESS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    EQUAL-(CW*(C_HOFFSET))
        DD    N_LESS

        POP     EDX      ;S1
        POP     EBX      ;S2
        XOR     EAX,EAX   ;0 default RESULT
        CMP     EBX,EDX
        JNL     LES1
        DEC     EAX
LES1:   PUSH    EAX
        JMP NEXT
;

;  **********
;  *   U<   *
;  **********
;
N_ULESS:   DD      2
        DB      "U<"
ULESS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LESS-(CW*(C_HOFFSET))
        DD    N_ULESS

        POP     EAX
        POP     EDX
        SUB     EDX,EAX
        SBB     EAX,EAX
        PUSH    EAX
        JMP NEXT
;

;  *********
;  *   >   *
;  *********
;
N_GREAT:   DD      1
        DB      ">"
GREAT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ULESS-(CW*(C_HOFFSET))
        DD    N_GREAT

        DD      SWAP
        DD      LESS
        DD      SEMIS
;

;  **********
;  *   <>   *
;  **********
;
N_UNEQ:   DD      2
        DB      "<>"
UNEQ:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    GREAT-(CW*(C_HOFFSET))
        DD    N_UNEQ

        DD      LSUB
        DD      ZEQU
        DD      ZEQU
        DD      SEMIS
;

;  ***********
;  *   ROT   *
;  ***********
;
N_ROT:   DD      3
        DB      "ROT"
ROT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    UNEQ-(CW*(C_HOFFSET))
        DD    N_ROT

        POP     EDX      ;S1
        POP     EBX      ;S2
        POP     EAX      ;S3
        PUSH    EBX
        PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  *************
;  *   SPACE   *
;  *************
;
N_SPACE:   DD      5
        DB      "SPACE"
SPACE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ROT-(CW*(C_HOFFSET))
        DD    N_SPACE

        DD      LBL
        DD      EMIT
        DD      SEMIS
;

;  ************
;  *   ?DUP   *
;  ************
;
N_QDUP:   DD      4
        DB      "?DUP"
QDUP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SPACE-(CW*(C_HOFFSET))
        DD    N_QDUP

        DD      LDUP
        DD      ZBRAN
        DD      QDUP1-$-CW ; IF
        DD      LDUP    ;THEN
QDUP1:  DD      SEMIS
;

;  **************
;  *   LATEST   *
;  **************
;
N_LATEST:   DD      6
        DB      "LATEST"
LATEST:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QDUP-(CW*(C_HOFFSET))
        DD    N_LATEST

        DD      CURR
        DD      FETCH
        DD      TLFA
        DD      FETCH
        DD      SEMIS
;

;  ************
;  *   >CFA   *
;  ************
;
N_TCFA:   DD      4
        DB      ">CFA"
TCFA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LATEST-(CW*(C_HOFFSET))
        DD    N_TCFA

        DD      LIT, (CW*(C_HOFFSET))
        DD      PLUS
        DD      SEMIS
;

;  ************
;  *   >DFA   *
;  ************
;
N_TDFA:   DD      4
        DB      ">DFA"
TDFA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TCFA-(CW*(C_HOFFSET))
        DD    N_TDFA

        DD      LIT, (CW*(D_HOFFSET))
        DD      PLUS
        DD      SEMIS
;

;  ************
;  *   >FFA   *
;  ************
;
N_TFFA:   DD      4
        DB      ">FFA"
TFFA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TDFA-(CW*(C_HOFFSET))
        DD    N_TFFA

        DD      LIT, (CW*(F_HOFFSET))
        DD      PLUS
        DD      SEMIS
;

;  ************
;  *   >LFA   *
;  ************
;
N_TLFA:   DD      4
        DB      ">LFA"
TLFA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TFFA-(CW*(C_HOFFSET))
        DD    N_TLFA

        DD      LIT, (CW*(L_HOFFSET))
        DD      PLUS
        DD      SEMIS
;

;  ************
;  *   >NFA   *
;  ************
;
N_TNFA:   DD      4
        DB      ">NFA"
TNFA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TLFA-(CW*(C_HOFFSET))
        DD    N_TNFA

        DD      LIT,(CW*(N_HOFFSET))
        DD      PLUS
        DD      SEMIS
;
;

;  ************
;  *   >PHA   *
;  ************
;
N_TPHA:   DD      4
        DB      ">PHA"
TPHA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TNFA-(CW*(C_HOFFSET))
        DD    N_TPHA

        DD      LIT,(CW*(PH_OFFSET))
        DD      PLUS
        DD      SEMIS
;

;  *************
;  *   >BODY   *
;  *************
;
N_TOBODY:   DD      5
        DB      ">BODY"
TOBODY:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TPHA-(CW*(C_HOFFSET))
        DD    N_TOBODY

        DD      CTOD
        DD      TDFA, FETCH
        DD      CELLP           ; Skip DOES> pointer.
        DD      SEMIS
;

;  *************
;  *   BODY>   *
;  *************
;
N_BODYF:   DD      5
        DB      "BODY>"
BODYF:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TOBODY-(CW*(C_HOFFSET))
        DD    N_BODYF

        DD      LIT,(CW*(BD_OFFSET))
        DD      LSUB
        DD      SEMIS
;

;  ************
;  *   CFA>   *
;  ************
;
N_CTOD:   DD      4
        DB      "CFA>"
CTOD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BODYF-(CW*(C_HOFFSET))
        DD    N_CTOD

        DD      LIT,(CW*(C_HOFFSET))
        DD      LSUB
        DD      SEMIS
;

;  ************
;  *   >WID   *
;  ************
;
N_TWID:   DD      4
        DB      ">WID"
TWID:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CTOD-(CW*(C_HOFFSET))
        DD    N_TWID

        DD      TOBODY
        DD      CELLP ; Skip vfa link.
        DD      SEMIS
;

;  ************
;  *   >VFA   *
;  ************
;
N_TVFA:   DD      4
        DB      ">VFA"
TVFA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TWID-(CW*(C_HOFFSET))
        DD    N_TVFA

        DD      TOBODY
        DD      SEMIS
;


;  ************
;  *   !CSP   *
;  ************
;
N_SCSP:   DD      4
        DB      "!CSP"
SCSP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TVFA-(CW*(C_HOFFSET))
        DD    N_SCSP

        DD      SPFET
        DD      LCSP
        DD      STORE
        DD      SEMIS
;
;

;  **************
;  *   ?ERROR   *
;  **************
;
N_QERR:   DD      6
        DB      "?ERROR"
QERR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SCSP-(CW*(C_HOFFSET))
        DD    N_QERR

        DD      SWAP
        DD      ZBRAN
        DD      QERR1-$-CW ;IF
        DD      LIN, FETCH
        DD      SRC, FETCH
        DD      LWHERE, TSTOR
        DD      THROW
        DD      BRAN
        DD      QERR2-$-CW  ;ELSE
QERR1:  DD      DROP    ;THEN
QERR2:  DD      SEMIS
;

;  **************
;  *   ?ERRUR   *
;  **************
;
N_QERRUR:   DD      6
        DB      "?ERRUR"
QERRUR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QERR-(CW*(C_HOFFSET))
        DD    N_QERRUR

        DD      ZERO, MIN, LDUP, QERR
        DD      SEMIS
;


;  **************
;  *   ?DELIM   *
;  **************
;
N_QDELIM:   DD      6
        DB      "?DELIM"
QDELIM:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QERRUR-(CW*(C_HOFFSET))
        DD    N_QDELIM

        DD      INBRS
        DD      QBL
        DD      ZEQU
        DD      LIT, 10, QERR
        DD      DROP
        DD      SEMIS
;

;  ************
;  *   ?CSP   *
;  ************
;
N_QCSP:   DD      4
        DB      "?CSP"
QCSP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QDELIM-(CW*(C_HOFFSET))
        DD    N_QCSP

        DD      SPFET
        DD      LCSP
        DD      FETCH
        DD      LSUB
        DD      LIT, 20, QERR
        DD      SEMIS
;

;  *************
;  *   ?COMP   *
;  *************
;
N_QCOMP:   DD      5
        DB      "?COMP"
QCOMP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QCSP-(CW*(C_HOFFSET))
        DD    N_QCOMP

        DD      STATE
        DD      FETCH
        DD      ZEQU
        DD      LIT, 17, QERR
        DD      SEMIS
;

;  *************
;  *   ?EXEC   *
;  *************
;
N_QEXEC:   DD      5
        DB      "?EXEC"
QEXEC:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QCOMP-(CW*(C_HOFFSET))
        DD    N_QEXEC

        DD      STATE
        DD      FETCH
        DD      LIT, 18, QERR
        DD      SEMIS
;

;  **************
;  *   ?PAIRS   *
;  **************
;
N_QPAIR:   DD      6
        DB      "?PAIRS"
QPAIR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QEXEC-(CW*(C_HOFFSET))
        DD    N_QPAIR

        DD      LSUB
        DD      LIT, 19, QERR
        DD      SEMIS
;


;  ****************
;  *   ?LOADING   *
;  ****************
;
N_QLOAD:   DD      8
        DB      "?LOADING"
QLOAD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QPAIR-(CW*(C_HOFFSET))
        DD    N_QLOAD

        DD      BLK
        DD      FETCH
        DD      ZEQU
        DD      LIT, 22, QERR
        DD      SEMIS
;
;
;
;

;  *********
;  *   [   *
;  *********
;
N_LBRAC:   DD      1
        DB      "["
LBRAC:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    QLOAD-(CW*(C_HOFFSET))
        DD    N_LBRAC

        DD      ZERO
        DD      STATE
        DD      STORE
        DD      SEMIS
;

;  *********
;  *   ]   *
;  *********
;
N_RBRAC:   DD      1
        DB      "]"
RBRAC:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LBRAC-(CW*(C_HOFFSET))
        DD    N_RBRAC

        DD      ONE
        DD      STATE
        DD      STORE
        DD      SEMIS
;

;  **************
;  *   HIDDEN   *
;  **************
;
N_HIDDEN:   DD      6
        DB      "HIDDEN"
HIDDEN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RBRAC-(CW*(C_HOFFSET))
        DD    N_HIDDEN

        DD      TFFA
        DD      LIT,B_INVIS
        DD      TOGGL
        DD      SEMIS
;

;  ***********
;  *   HEX   *
;  ***********
;
N_HEX:   DD      3
        DB      "HEX"
HEX:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    HIDDEN-(CW*(C_HOFFSET))
        DD    N_HEX

        DD      LIT,16
        DD      BASE
        DD      STORE
        DD      SEMIS
;

;  ***************
;  *   DECIMAL   *
;  ***************
;
N_DECA:   DD      7
        DB      "DECIMAL"
DECA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    HEX-(CW*(C_HOFFSET))
        DD    N_DECA

        DD      LIT,10
        DD      BASE
        DD      STORE
        DD      SEMIS
;

;  ***************
;  *   (;CODE)   *
;  ***************
;
N_PSCOD:   DD      7
        DB      "(;CODE)"
PSCOD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DECA-(CW*(C_HOFFSET))
        DD    N_PSCOD

        DD      FROMR
        DD      LATEST
        DD      TCFA
        DD      STORE
        DD      SEMIS
;

;

;  **************
;  *   CREATE   *
;  **************
;
N_CREATE:   DD      6
        DB      "CREATE"
CREATE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PSCOD-(CW*(C_HOFFSET))
        DD    N_CREATE

        DD      LPWORD
        DD      PCREAT
        DD      LIT, HLNOOP, COMMA
        DD      PSCOD
DODOE:  LEA     EBP,[EBP - (CW*(1))] ;Pop HIP.
        MOV     [EBP],ESI
        MOV     ESI,[EAX+(CW*((D_HOFFSET-C_HOFFSET)))] ;NEW IP 
        LEA     EAX,[ESI+(CW*(1))]
        MOV     ESI,[ESI]
        PUSH    EAX
        JMP NEXT
HLNOOP: DD      SEMIS
;

;  *************
;  *   DOES>   *
;  *************
;
N_DOES:   DD      5
        DB      "DOES>"
DOES:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CREATE-(CW*(C_HOFFSET))
        DD    N_DOES

        DD      FROMR
        DD      LATEST
        DD      TDFA
        DD      FETCH
        DD      STORE
        DD      SEMIS
;

;  *************
;  *   COUNT   *
;  *************
;
N_COUNT:   DD      5
        DB      "COUNT"
COUNT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DOES-(CW*(C_HOFFSET))
        DD    N_COUNT

        DD      LDUP
        DD      ONEP
        DD      SWAP
        DD      CFET
        DD      SEMIS
;

;  *****************
;  *   -TRAILING   *
;  *****************
;
N_DTRAI:   DD      9
        DB      "-TRAILING"
DTRAI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    COUNT-(CW*(C_HOFFSET))
        DD    N_DTRAI

        DD      LDUP
        DD      ZERO
        DD     XDO
        DD      DTRA4-$-CW
DTRA1:  DD      OVER
        DD      OVER
        DD      PLUS
        DD      ONE
        DD      LSUB
        DD      CFET
        DD      LBL
        DD      LSUB
        DD      ZBRAN
        DD      DTRA2-$-CW ;IF
        DD      LLEAV
DTRA2:  DD      ONE
        DD      LSUB    ; THEN
        DD     XLOOP
        DD      DTRA1-$-CW    ; LOOP
DTRA4:
        DD      SEMIS
;


;  **********
;  *   S"   *
;  **********
;
N_SQUOT:   DD      2
        DB      'S"'
SQUOT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    DTRAI-(CW*(C_HOFFSET))
        DD    N_SQUOT

        DD      DENQ
        DD      SEMIS
;
;

;  **********
;  *   ."   *
;  **********
;
N_DOTQ:   DD      2
        DB      '."'
DOTQ:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    SQUOT-(CW*(C_HOFFSET))
        DD    N_DOTQ

        DD      DENQ
        DD      STATE
        DD      FETCH
        DD      ZBRAN
        DD      DOTQ1-$-CW ; IF
        DD      LIT, LTYPE, COMMA
        DD      BRAN
        DD      DOTQ2-$-CW
DOTQ1:
        DD      LTYPE
DOTQ2:
        DD      SEMIS   ; THEN
;

;  **********
;  *   .(   *
;  **********
;
N_DOTP:   DD      2
        DB      ".("
DOTP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    DOTQ-(CW*(C_HOFFSET))
        DD    N_DOTP

        DD      LIT, ')'
        DD      PPARS
        DD      LTYPE
        DD      SEMIS
;

;  ***************
;  *   SET-SRC   *
;  ***************
;
N_SETSRC:   DD      7
        DB      "SET-SRC"
SETSRC:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DOTP-(CW*(C_HOFFSET))
        DD    N_SETSRC

        DD      OVER, PLUS
        DD      SWAP, SRC, TSTOR
        DD      SRC, FETCH
        DD      LIN, STORE ;  IN

;       DD      DOTS
        DD      SEMIS
;

;  ****************
;  *   EVALUATE   *
;  ****************
;
N_EVALUATE:   DD      8
        DB      "EVALUATE"
EVALUATE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SETSRC-(CW*(C_HOFFSET))
        DD    N_EVALUATE

        DD      SAVE
        DD      SETSRC
        DD      LIT, INTER, CATCH
        DD      RESTO
        DD      THROW
        DD      SEMIS
;

;  ************
;  *   FILL   *
;  ************
;
N_FILL:   DD      4
        DB      "FILL"
FILL:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    EVALUATE-(CW*(C_HOFFSET))
        DD    N_FILL

        POP     EAX      ; FILL CHAR
        POP     ECX      ; FILL COUNT
        POP     EDI      ; BEGIN ADDR
;       MOV    BX,DS
;       MOV    ES,BX   ; ES <- DS
        CLD             ; INC DIRECTION
        REP     STOSB   ;STORE BYTE
        JMP NEXT
;

;  ************
;  *   CORA   *
;  ************
;
N_CORA:   DD      4
        DB      "CORA"
CORA:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FILL-(CW*(C_HOFFSET))
        DD    N_CORA

;       MOV    ES,BX   ; ES <- DS
;       MOV    BX,DS
        MOV     EDX,ESI   ;SAVE
        XOR     EAX,EAX   ; Result
        POP     ECX      ; count
        POP     EDI      ; addr2
        POP     ESI      ; addr1
        CLD             ; INC DIRECTION
        REP     CMPSB   ; Compare BYTE
        JZ      CORA3
        MOV     AL,1    ;Remainder is already 0
        JNC     CORA3
        NEG     EAX
CORA3:
        MOV     ESI,EDX  ;Restore
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   $I   *
;  **********
;
N_SINDEX:   DD      2
        DB      "$I"
SINDEX:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CORA-(CW*(C_HOFFSET))
        DD    N_SINDEX

;       MOV    ES,BX   ; ES <- DS
;       MOV    BX,DS
        POP     EAX      ; char
        POP     ECX      ; count
        POP     EDI      ; addr
        OR      EDI,EDI   ;Clear zero flag.
        CLD             ; INC DIRECTION
        REPNZ     SCASB   ; Compare BYTE
        JZ      SINDEX1
        XOR     EDI,EDI    ;Not found: 0
        INC     EDI
SINDEX1:
        DEC     EDI
        PUSH    EDI
        JMP NEXT
;

;  **********
;  *   $S   *
;  **********
;
N_SSPLIT:   DD      2
        DB      "$S"
SSPLIT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SINDEX-(CW*(C_HOFFSET))
        DD    N_SSPLIT

;       MOV    ES,BX   ; ES <- DS
;       MOV    BX,DS
        POP     EAX      ; char
        POP     ECX      ; count
        MOV     EBX,ECX
        POP     EDI      ; addr
        OR      EDI,EDI   ;Clear zero flag.
        MOV     EDX,EDI   ; Copy
        CLD             ; INC DIRECTION
        REPNZ     SCASB   ; Compare BYTE
        JZ      SSPLIT1
; Not present.
        PUSH    ECX   ; Nil pointer.
        JMP SSPLIT2
SSPLIT1:
        PUSH    EDI
        SUB     EBX,ECX
        DEC     EBX      ;Delimiter is not part of first string.
SSPLIT2:
        PUSH    ECX   ;Remaining length
        PUSH    EDX   ;Start of first string.
        PUSH    EBX   ;Skipped length.
        JMP NEXT
;

;  *************
;  *   ERASE   *
;  *************
;
N_LERASE:   DD      5
        DB      "ERASE"
LERASE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SSPLIT-(CW*(C_HOFFSET))
        DD    N_LERASE

        DD      ZERO
        DD      FILL
        DD      SEMIS
;


;  *************
;  *   BLANK   *
;  *************
;
N_BLANK:   DD      5
        DB      "BLANK"
BLANK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LERASE-(CW*(C_HOFFSET))
        DD    N_BLANK

        DD      LBL
        DD      FILL
        DD      SEMIS
;
;

;  ************
;  *   HOLD   *
;  ************
;
N_HOLD:   DD      4
        DB      "HOLD"
HOLD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BLANK-(CW*(C_HOFFSET))
        DD    N_HOLD

        DD      LIT,-1
        DD      HLD
        DD      PSTORE
        DD      HLD
        DD      FETCH
        DD      CSTOR
        DD      SEMIS
;

;  ***********
;  *   PAD   *
;  ***********
;
N_PAD:   DD      3
        DB      "PAD"
PAD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    HOLD-(CW*(C_HOFFSET))
        DD    N_PAD

        DD      HERE
; Allow for a one line name, a double binary number and some hold char's
        DD      LIT,84+128+64
        DD      PLUS
        DD      SEMIS
;


;  ************
;  *   WORD   *
;  ************
;
N_IWORD:   DD      4
        DB      "WORD"
IWORD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PAD-(CW*(C_HOFFSET))
        DD    N_IWORD

        DD      LDUP, LBL, EQUAL
        DD      ZBRAN
        DD      IWORD1-$-CW
         DD      DROP
         DD      LPWORD
        DD      BRAN
        DD      IWORD2-$-CW
IWORD1: DD      TOR
IWORD3:  DD      INBRS, RR, EQUAL
        DD      ZBRAN
        DD      IWORD4-$-CW
        DD      DROP
        DD      BRAN
        DD      IWORD3-$-CW
IWORD4:
        DD      DROP
        DD      LIT, -1, LIN, PSTORE ; Backtrace to first non-delimiter.
        DD      FROMR, PPARS
;        DD      DOTS
IWORD2:
        DD      HERE
        DD      LIT,22H
        DD      BLANK
        DD      HERE
        DD      SSTORBD     ; FIXME
        DD      HERE
;        DD      DOTS
        DD      SEMIS
;
;

;  ************
;  *   CHAR   *
;  ************
;
N_LCHAR:   DD      4
        DB      "CHAR"
LCHAR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    IWORD-(CW*(C_HOFFSET))
        DD    N_LCHAR

        DD      LPWORD, DROP, CFET, LITER
        DD      SEMIS
;

;  **************
;  *   [CHAR]   *
;  **************
;
N_BCHAR:   DD      6
        DB      "[CHAR]"
BCHAR:        DD    DOCOL
        DD    (LCHAR+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    B_IMMED
        DD    LCHAR-(CW*(C_HOFFSET))
        DD    N_BCHAR

;

;  ****************
;  *   (NUMBER)   *
;  ****************
;
N_PNUMB:   DD      8
        DB      "(NUMBER)"
PNUMB:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BCHAR-(CW*(C_HOFFSET))
        DD    N_PNUMB

        DD      ZERO, ZERO
        DD      ZERO, DPL, STORE
NPNUM1:  DD      INBRS   ; BEGIN
        DD      LDUP, LIT, ADOT, EQUAL
        DD      ZBRAN
        DD      NPNUM2A-$-CW ; IF
        DD      DROP, DPL, STORE, ZERO
        DD      BRAN
        DD      NPNUM3-$-CW ; ELSE
NPNUM2A:
        DD      LDUP, LIT, ',', EQUAL
        DD      ZBRAN
        DD      NPNUM2-$-CW ; IF
        DD      TDROP, ZERO
        DD      BRAN
        DD      NPNUM3-$-CW ; ELSE
NPNUM2:
        DD      LDUP, QBL
        DD      ZBRAN
        DD      NPNUM4-$-CW ; IF
        DD      DROP, DROP, ONE
        DD      BRAN
        DD      NPNUM3-$-CW ; ELSE
NPNUM4:
        DD      SWAP, DROP
        DD      BASE, FETCH, DIGIT
        DD      ZEQU
        DD      LIT, 10, QERR

        DD      SWAP
        DD      BASE
        DD      FETCH
        DD      USTAR
        DD      DROP
        DD      ROT
        DD      BASE
        DD      FETCH
        DD      USTAR
        DD      DPLUS
        DD      ZERO
NPNUM3:                 ; THEN THEN
        DD      ZBRAN
        DD      NPNUM1-$-CW
        DD      SEMIS
;

;  **************
;  *   NUMBER   *
;  **************
;
N_NUMB:   DD      6
        DB      "NUMBER"
NUMB:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PNUMB-(CW*(C_HOFFSET))
        DD    N_NUMB

LNUMB:
        DD      LIT, -1, LIN, PSTORE
        DD      PNUMB, SDLITE
        DD      SEMIS
;


;  ***************
;  *   >NUMBER   *
;  ***************
;
N_TONUMB:   DD      7
        DB      ">NUMBER"
TONUMB:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    NUMB-(CW*(C_HOFFSET))
        DD    N_TONUMB

        DD      TDUP, PLUS, TOR     ; End available on return stack.
        DD      ZERO
        DD     XQDO
        DD      TONUM9-$-CW
TONUM1:
        DD      LDUP, CFET, BASE, FETCH, DIGIT
        DD      ZEQU
        DD      ZBRAN
        DD      TONUM4-$-CW ; IF
        DD      LLEAV
TONUM4:
        DD      SWAP, TOR ; Address out of the way.
        DD      SWAP
        DD      BASE
        DD      FETCH
        DD      USTAR
        DD      DROP
        DD      ROT
        DD      BASE
        DD      FETCH
        DD      USTAR
        DD      DPLUS
        DD      FROMR, ONEP     ; Address back.
        DD     XLOOP
        DD      TONUM1-$-CW
TONUM9:
        DD      FROMR
        DD      OVER, LSUB
        DD      SEMIS
;
;

;  *************
;  *   FOUND   *
;  *************
;
N_FOUND:   DD      5
        DB      "FOUND"
FOUND:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TONUMB-(CW*(C_HOFFSET))
        DD    N_FOUND

        DD      SEARCH, TOR
FOUND1: DD      RR, FETCH
;        DD      DOTS
        DD      PFIND, LDUP, ZEQU
        DD      ZBRAN
        DD      FOUND3-$-CW
        DD      DROP
        DD      RR, FETCH, LIT, FORTH, LSUB ;Was this ONLY?
        DD      ZBRAN
        DD      FOUND2-$-CW
        DD      FROMR, CELLP, TOR
        DD      BRAN
        DD      FOUND1-$-CW
FOUND2: DD      ZERO
FOUND3: DD      RDROP
        DD      SWAP,DROP,SWAP,DROP
        DD      SEMIS
;

;  ************
;  *   FIND   *
;  ************
;
N_FIND:   DD      4
        DB      "FIND"
FIND:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FOUND-(CW*(C_HOFFSET))
        DD    N_FIND

        DD      LDUP, COUNT, FOUND
        DD      LDUP
        DD      ZBRAN
        DD      FIND1-$-CW ;IF
        DD      SWAP, DROP ; The address.
        ; Fine point, get xt by TCFA. Even if a NOOP.
        DD      LDUP, TCFA, SWAP
        DD      TFFA, FETCH
        DD      LIT, B_IMMED, LAND
        DD      LIT, -1, SWAP
        DD      ZBRAN
        DD      FIND1-$-CW ;IF
        DD      NEGATE
FIND1:               ;THEN THEN
        DD      SEMIS
;

;  **************
;  *   (FIND)   *
;  **************
;
N_PFIND:   DD      6
        DB      "(FIND)"
PFIND:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FIND-(CW*(C_HOFFSET))
        DD    N_PFIND

        DD      ZERO, RESULT, STORE
        DD      LIT, MATCHING, SWAP, FORW
        DD      RESULT,FETCH
        DD      SEMIS
;

;  *************
;  *   ERROR   *
;  *************
;
N_ERROR:   DD      5
        DB      "ERROR"
ERROR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PFIND-(CW*(C_HOFFSET))
        DD    N_ERROR

        DD      LWHERE, TFET
        DD      OVER, LIT, 20, LSUB
        DD      MAX
        DD      SWAP,OVER, LSUB
        DD      ETYPE
        DD      SKIP
         DD      18
SB3: DB      "? ciforth ERROR # "
       
        DD      LIT, SB3
        DD      LIT, 18
        DD      ETYPE
        DD      BASE, FETCH
        DD      DECA
        DD      OVER
        DD      STOD, ZERO, PDDOTR      ;This is about (.) 
        DD      ETYPE
        DD      BASE, STORE
        DD      MESS
        DD      SEMIS
;

;  *************
;  *   CATCH   *
;  *************
;
N_CATCH:   DD      5
        DB      "CATCH"
CATCH:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ERROR-(CW*(C_HOFFSET))
        DD    N_CATCH

        DD      SPFET, CELLP, TOR
        DD      HANDLER, FETCH, TOR
        DD      RPFET, HANDLER, STORE
        DD      EXEC
        DD      FROMR, HANDLER, STORE
        DD      RDROP, ZERO
        DD      SEMIS
;

;  *************
;  *   THROW   *
;  *************
;
N_THROW:   DD      5
        DB      "THROW"
THROW:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    CATCH-(CW*(C_HOFFSET))
        DD    N_THROW

        DD      QDUP
        DD      ZBRAN
        DD      THROW1-$-CW
        DD      HANDLER, FETCH, ZEQU
        DD      ZBRAN
        DD      THROW2-$-CW
        DD      ERROR
        DD      MTBUF  ; A (too) crude way to remove locks
        DD      SZERO, FETCH, SPSTO
        DD      QUIT
THROW2:
        DD      HANDLER, FETCH, RPSTO
        DD      FROMR, HANDLER, STORE
        DD      FROMR, SWAP, TOR
        DD      SPSTO
        DD      FROMR
THROW1:
        DD      SEMIS
;


;  ****************
;  *   (ABORT")   *
;  ****************
;
N_PABORTQ:   DD      8
        DB      '(ABORT")'
PABORTQ:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    THROW-(CW*(C_HOFFSET))
        DD    N_PABORTQ

        DD      ROT
        DD      ZBRAN
        DD      PABQ1-$-CW ;IF
        DD      ETYPE
        DD      SIGNON, ABORT
        DD      BRAN
        DD      PABQ2-$-CW ;ELSE
PABQ1:  DD       TDROP
PABQ2:   DD      SEMIS
;

;  **************
;  *   ABORT"   *
;  **************
;
N_ABORTQ:   DD      6
        DB      'ABORT"'
ABORTQ:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    PABORTQ-(CW*(C_HOFFSET))
        DD    N_ABORTQ

        DD      QCOMP
        DD      DENQ
        DD      LIT, PABORTQ, COMMA
        DD      SEMIS
;
;

;  ***********
;  *   ID.   *
;  ***********
;
N_IDDOT:   DD      3
        DB      "ID."
IDDOT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ABORTQ-(CW*(C_HOFFSET))
        DD    N_IDDOT

        DD      LDUP, TFFA
        DD      FETCH, LIT, B_DUMMY, LXOR
        DD      ZBRAN
        DD      IDDOT1-$-CW
        DD      TNFA
        DD      FETCH
        DD      SFET
        DD      LTYPE
        DD      SPACE
        DD      SPACE
        DD      SPACE
        DD      BRAN
        DD      IDDOT2-$-CW
IDDOT1:
        DD      DROP
IDDOT2:
        DD      SEMIS
;

;  ****************
;  *   (CREATE)   *
;  ****************
;
N_PCREAT:   DD      8
        DB      "(CREATE)"
PCREAT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    IDDOT-(CW*(C_HOFFSET))
        DD    N_PCREAT

        DD      LDUP
        DD      ZEQU
        DD      LIT, 5, QERR
        DD      TDUP
        DD      FOUND
        DD      LDUP
        DD      ZBRAN
        DD      CREA1-$-CW ;IF
        DD      LDUP, TFFA, FETCH
        DD      LIT, B_DENOT, LAND, ZEQU
        DD      ZBRAN
        DD      CREA1-$-CW ;IF
        DD      IDDOT
        DD      LIT,4
        DD      MESS
        DD      SPACE   ;THEN
        DD      ZERO
CREA1:  DD      DROP
        DD      SCOMMA
        DD      HERE,TOR

        DD      RR, TPHA, COMMA         ; Code field.

        DD      RR, TPHA, COMMA         ; Data field.

        DD      ZERO, COMMA ; Flag field.

        DD      CURR, FETCH, TLFA
        DD      LDUP, FETCH, COMMA   ; Link field.
        DD      RR, SWAP, STORE

        DD      COMMA   ; Name field.

        DD      RDROP
        DD      SEMIS
;

;  *****************
;  *   [COMPILE]   *
;  *****************
;
N_BCOMP:   DD      9
        DB      "[COMPILE]"
BCOMP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    PCREAT-(CW*(C_HOFFSET))
        DD    N_BCOMP

        DD      LPWORD
        DD      FOUND
        DD      LDUP
        DD      ZEQU
        DD      ZERO, QERR
        DD      TCFA
        DD      COMMA
        DD      SEMIS
;

;  ****************
;  *   POSTPONE   *
;  ****************
;
N_POSTP:   DD      8
        DB      "POSTPONE"
POSTP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    BCOMP-(CW*(C_HOFFSET))
        DD    N_POSTP

        DD      LPWORD
        DD      FOUND
        DD      LDUP
        DD      ZEQU
        DD      ZERO, QERR
        DD      LDUP, TFFA, FETCH
        DD      LIT, B_IMMED, LAND, ZEQU
        DD      ZBRAN
        DD      POSTP1-$-CW
         DD      LIT, LIT, COMMA
         DD      COMMA
         DD      LIT, COMMA, COMMA
        DD      BRAN
        DD      POSTP2-$-CW
POSTP1:
         DD      COMMA
POSTP2:
        DD      SEMIS
;

;  ***************
;  *   LITERAL   *
;  ***************
;
N_LITER:   DD      7
        DB      "LITERAL"
LITER:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    POSTP-(CW*(C_HOFFSET))
        DD    N_LITER

        DD      STATE
        DD      FETCH
        DD      ZBRAN
        DD      LITE1-$-CW ;IF
        DD      LIT, LIT, COMMA
        DD      COMMA   ;THEN
LITE1:  DD      SEMIS
;

;  ****************
;  *   DLITERAL   *
;  ****************
;
N_DLITE:   DD      8
        DB      "DLITERAL"
DLITE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    LITER-(CW*(C_HOFFSET))
        DD    N_DLITE

        DD      STATE
        DD      FETCH
        DD      ZBRAN
        DD      DLIT1-$-CW ; IF
        DD      SWAP
        DD      LITER
        DD      LITER   ; THEN
DLIT1:  DD      SEMIS
;
;

;  *****************
;  *   SDLITERAL   *
;  *****************
;
N_SDLITE:   DD      9
        DB      "SDLITERAL"
SDLITE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    DLITE-(CW*(C_HOFFSET))
        DD    N_SDLITE

        DD      DPL
        DD      FETCH
        DD      ZBRAN
        DD      SDLIT1-$-CW ; IF
        DD      DLITE
        DD      BRAN
        DD      SDLIT2-$-CW ; IF
SDLIT1:
        DD      DROP, LITER
SDLIT2:
        DD      SEMIS
;


;  **************
;  *   ?STACK   *
;  **************
;
N_QSTAC:   DD      6
        DB      "?STACK"
QSTAC:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SDLITE-(CW*(C_HOFFSET))
        DD    N_QSTAC

        DD      SPFET
        DD      SZERO
        DD      FETCH
        DD      SWAP
        DD      ULESS
        DD      ONE, QERR
        DD      SPFET
        DD      HERE
        DD      LIT,80H
        DD      PLUS
        DD      ULESS
        DD      LIT, 7, QERR
        DD      SEMIS
        ;
;
;

;  *****************
;  *   INTERPRET   *
;  *****************
;
N_INTER:   DD      9
        DB      "INTERPRET"
INTER:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QSTAC-(CW*(C_HOFFSET))
        DD    N_INTER

INTE1:
        DD      LPWORD
        DD      LDUP      ; Zero length.
        DD      ZBRAN
        DD      INTE8-$-CW ;WHILE
;       DD      DOTS
;       DD      TDUP, LTYPE
        DD      OVER, TOR       ; Save old parse pointer.
        DD      FOUND
        DD      LDUP, ZEQU
        DD      LIT, 12, QERR
        DD      LDUP, TFFA, FETCH
        DD      LDUP, LIT, B_DENOT, LAND ;Retain copy of flags.
        DD      ZBRAN
        DD      INTE3B-$-CW ;IF
        DD      OVER, TNFA, FETCH, FETCH
        DD      RR, PLUS, LIN, STORE  ;Skip over prefix.
INTE3B:                  ;THEN 
        DD      RDROP           ; Drop old parse pointer.
        DD      LIT, B_IMMED, LAND
        DD      STATE, FETCH, ZEQU, LOR
        DD      ZBRAN
        DD      INTE3-$-CW ;IF
        DD      EXEC
        DD      BRAN
        DD      INTE4-$-CW ;IF
INTE3:
        DD      COMMA
                        ;THEN
INTE4:
        DD      QSTAC
        DD      BRAN
        DD      INTE1-$-CW  ;AGAIN
INTE8:  DD      DROP, DROP
        DD      SEMIS
;

;  *****************
;  *   IMMEDIATE   *
;  *****************
;
N_IMMED:   DD      9
        DB      "IMMEDIATE"
IMMED:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    INTER-(CW*(C_HOFFSET))
        DD    N_IMMED

        DD      LATEST
        DD      TFFA
        DD      LIT, B_IMMED
        DD      TOGGL
        DD      SEMIS
;

;  ******************
;  *   VOCABULARY   *
;  ******************
;
N_VOCAB:   DD      10
        DB      "VOCABULARY"
VOCAB:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    IMMED-(CW*(C_HOFFSET))
        DD    N_VOCAB

        DD      CREATE
        DD      LATEST   ; Link this DEA into VOC-LINK chain.
        DD      VOCL
        DD      FETCH
        DD      COMMA
        DD      VOCL
        DD      STORE
        DD      ZERO, COMMA   ; Dummy code field
        DD      ZERO, COMMA   ; Dummy data field
        DD      LIT, B_DUMMY, COMMA ; Dummy flag field
        DD      ZERO, COMMA ;Links to the word FORTH

        DD      DOES
DOVOC:
        DD      ALSO
        DD      CELLP   ; Make it a WID. 
        DD      SEARCH
        DD      STORE
        DD      SEMIS
        ;
;
;   The link to task is a cold start value only.
;   It is updated each time a definition is
;   appended to the 'FORTH' vocabulary.
;

;

;  *******************
;  *   DEFINITIONS   *
;  *******************
;
N_DEFIN:   DD      11
        DB      "DEFINITIONS"
DEFIN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    VOCAB-(CW*(C_HOFFSET))
        DD    N_DEFIN

        DD      SEARCH
        DD      FETCH
        DD      CURR
        DD      STORE
        DD      SEMIS
;

;  ************
;  *   ALSO   *
;  ************
;
N_ALSO:   DD      4
        DB      "ALSO"
ALSO:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DEFIN-(CW*(C_HOFFSET))
        DD    N_ALSO

        DD      SEARCH, LDUP, CELLP
        DD      LIT, (CW*(8-1))
        DD      LMOVE
        DD      LIT, FORTH  ;End sentinel for array of word lists.
        DD      SEARCH, LIT, (CW*(8)), PLUS
        DD      STORE ;Trim sets of wordset.
        DD      SEMIS
;

;  ****************
;  *   PREVIOUS   *
;  ****************
;
N_PREVI:   DD      8
        DB      "PREVIOUS"
PREVI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ALSO-(CW*(C_HOFFSET))
        DD    N_PREVI

        DD      SEARCH, LDUP, CELLP, SWAP
        DD      LIT, (CW*(8))
        DD      LMOVE
        DD      SEMIS
;

;  ************
;  *   ONLY   *
;  ************
;
N_ONLY:   DD      4
        DB      "ONLY"
ONLY:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PREVI-(CW*(C_HOFFSET))
        DD    N_ONLY

        DD      LIT, FORTH, SEARCH, STORE
        DD      SEARCH, LDUP, CELLP
        DD      LIT, (CW*(8-1))
        DD      LCMOVE
        DD      SEMIS
;

;  *********
;  *   (   *
;  *********
;
N_PAREN:   DD      1
        DB      "("
PAREN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    ONLY-(CW*(C_HOFFSET))
        DD    N_PAREN

        DD      LIT,')'
        DD      PPARS
        DD      TDROP
        DD      SEMIS
;
;

;  *********
;  *   \   *
;  *********
;
N_BACKS:   DD      1
        DB      "\"
BACKS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    PAREN-(CW*(C_HOFFSET))
        DD    N_BACKS

        DD      LIT,ALF
        DD      PPARS
        DD      TDROP
        DD      SEMIS
;

;  ************
;  *   QUIT   *
;  ************
;
N_QUIT:   DD      4
        DB      "QUIT"
QUIT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BACKS-(CW*(C_HOFFSET))
        DD    N_QUIT

        DD      LBRAC
QUIT1:                  ;BEGIN
        DD      RZERO
        DD      FETCH
        DD      RPSTO
        
        DD      PACCEP
;
        DD       SETSRC
        DD      INTER
        DD      OK
        DD      BRAN
        DD      QUIT1-$-CW  ;AGAIN
        DD      SEMIS   ;Unnecessary, but helpful for decompilation.
;

;  **********
;  *   OK   *
;  **********
;
N_OK:   DD      2
        DB      "OK"
OK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QUIT-(CW*(C_HOFFSET))
        DD    N_OK

        DD      STATE
        DD      FETCH
        DD      ZEQU
        DD      ZBRAN
        DD      OK2-$-CW ;IF
        DD      SKIP
         DD      3
SB4: DB      " OK"
       
        DD      LIT, SB4
        DD      LIT, 3
        DD      LTYPE
        DD      CR
OK2:
        DD      SEMIS
;

;  *************
;  *   ABORT   *
;  *************
;
N_ABORT:   DD      5
        DB      "ABORT"
ABORT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    OK-(CW*(C_HOFFSET))
        DD    N_ABORT

        DD      SZERO, FETCH, SPSTO
        DD      ZERO, HANDLER, STORE
        DD      DECA
        DD      ONLY
        DD      FORTH
        DD      DEFIN
        DD      QUIT
        DD      SEMIS   ;Unnecessary, but helpful for decompilation.
;
;      WARM START VECTOR COMES HERE
;      For booting code we enter here, real mode and using the switchsegment.
;      BY control BREAK.
WARM_ENTRY:
; 
        
        MOV     ESI, WRM1
        JMP NEXT                   ;Hope stacks are still okay.
;
WRM1:   DD      WARM
;

;  ************
;  *   WARM   *
;  ************
;
N_WARM:   DD      4
        DB      "WARM"
WARM:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ABORT-(CW*(C_HOFFSET))
        DD    N_WARM

        DD      MTBUF
        DD      SIGNON
        DD      ABORT
        DD      SEMIS   ;Unnecessary, but helpful for decompilation.
;


;  ***************
;  *   OPTIONS   *
;  ***************
;
N_OPTIONS:   DD      7
        DB      "OPTIONS"
OPTIONS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    WARM-(CW*(C_HOFFSET))
        DD    N_OPTIONS

;       Execute option.


        DD      FETCH
        DD      LDUP
        DD      LIT,  , LAND
        DD      LIT, '-', UNEQ
        DD      ZBRAN
        DD      OPT3-$-CW
        DD      LIT, 3, LDUP, ERROR
        DD      XCODE, STORE, BYE
OPT3:
        DD      LIT, 8, RSHIFT
        DD      LIT, 1FH, LAND
        DD      LOAD
        DD      ZERO, SWAP ; Sign on suppressed.
OPT4:
        DD      DROP
        DD      SEMIS   ;Unnecessary, but helpful for decompilation.
;


;  ************
;  *   COLD   *
;  ************
;
N_COLD:   DD      4
        DB      "COLD"
COLD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    OPTIONS-(CW*(C_HOFFSET))
        DD    N_COLD

        DD      ZERO, HANDLER, STORE
        DD      MTBUF
        DD      FIRST
        DD      STALEST,STORE
        DD      FIRST
        DD      PREV,STORE
; Fill user area for single task.
        DD      LIT, USINI
        DD      LIT, USINI+(CW*(1)), FETCH
        DD      LIT, US
        DD      LCMOVE

        DD      LIT, 0, BLINI  ;Default, don't write in the library file!
;
        DD      DECA    ; FIXME has to go done by ABORT anyway.
        DD      ONLY    ; FIXME has to go done by ABORT anyway.
        DD      FORTH   ; FIXME has to go done by ABORT anyway.
        DD      DEFIN   ; FIXME has to go done by ABORT anyway.
        DD      ONE            ; Sign on wanted.
;
        DD      OPTIONS
        DD      ZBRAN
        DD      COLD5-$-CW
        DD      SIGNON    ; Suppressed for scripting! Or any options.
COLD5:
        DD      ABORT
        DD      BYE     ; In case of turnkey programs.
        DD      SEMIS   ; Unnecessary, but helpful for decompilation.
;

;  ***********
;  *   S>D   *
;  ***********
;
N_STOD:   DD      3
        DB      "S>D"
STOD:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    COLD-(CW*(C_HOFFSET))
        DD    N_STOD

        POP     EDX      ;S1
        SUB     EAX,EAX
        OR      EDX,EDX
        JNS     STOD1   ;POS
        DEC     EAX      ;NEG
STOD1:  PUSH    EDX
        PUSH    EAX
        JMP NEXT
;

;  ***********
;  *   ABS   *
;  ***********
;
N_LABS:   DD      3
        DB      "ABS"
LABS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    STOD-(CW*(C_HOFFSET))
        DD    N_LABS

        DD      LDUP
        DD      ZLESS
        DD      ZBRAN
        DD      PM1-$-CW   ;IF
        DD      NEGATE   ;THEN
PM1:
        DD      SEMIS
;

;  ************
;  *   DABS   *
;  ************
;
N_DABS:   DD      4
        DB      "DABS"
DABS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LABS-(CW*(C_HOFFSET))
        DD    N_DABS

        DD      LDUP
        DD      ZLESS
        DD      ZBRAN
        DD      DPM1-$-CW  ;IF
        DD      DNEGA   ;THEN
DPM1:
        DD      SEMIS
;

;  ***********
;  *   MIN   *
;  ***********
;
N_MIN:   DD      3
        DB      "MIN"
MIN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DABS-(CW*(C_HOFFSET))
        DD    N_MIN

        DD      TDUP
        DD      GREAT
        DD      ZBRAN
        DD      MIN1-$-CW  ;IF
        DD      SWAP    ;THEN
MIN1:   DD      DROP
        DD      SEMIS
;

;  ***********
;  *   MAX   *
;  ***********
;
N_MAX:   DD      3
        DB      "MAX"
MAX:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MIN-(CW*(C_HOFFSET))
        DD    N_MAX

        DD      TDUP
        DD      LESS
        DD      ZBRAN
        DD      MAX1-$-CW  ;IF
        DD      SWAP    ;THEN
MAX1:   DD      DROP
        DD      SEMIS
;

;  **************
;  *   LSHIFT   *
;  **************
;
N_LSHIFT:   DD      6
        DB      "LSHIFT"
LSHIFT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MAX-(CW*(C_HOFFSET))
        DD    N_LSHIFT

        POP     ECX
        POP     EAX
        SHL     EAX,CL
        PUSH    EAX
        JMP NEXT
;

;  **************
;  *   RSHIFT   *
;  **************
;
N_RSHIFT:   DD      6
        DB      "RSHIFT"
RSHIFT:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LSHIFT-(CW*(C_HOFFSET))
        DD    N_RSHIFT

        POP     ECX
        POP     EAX
        SHR     EAX,CL
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   M*   *
;  **********
;
N_MSTAR:   DD      2
        DB      "M*"
MSTAR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RSHIFT-(CW*(C_HOFFSET))
        DD    N_MSTAR

        DD      TDUP
        DD      LXOR
        DD      TOR
        DD      LABS
        DD      SWAP
        DD      LABS
        DD      USTAR
        DD      FROMR
        DD      ZLESS
        DD      ZBRAN
        DD      DPM2-$-CW  ;IF
        DD      DNEGA   ;THEN
DPM2:
        DD      SEMIS
;

;  **************
;  *   SM/REM   *
;  **************
;
N_MSLAS:   DD      6
        DB      "SM/REM"
MSLAS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MSTAR-(CW*(C_HOFFSET))
        DD    N_MSLAS

        POP     EBX      ;DIVISOR
        POP     EDX      ;MSW OF DIVIDEND
        POP     EAX      ;LSW OF DIVIDEND
        IDIV     EBX      ;16 BIT DIVIDE
        PUSH    EDX
        PUSH    EAX
        JMP NEXT          ;STORE QUOT/REM
;


;  **********
;  *   2/   *
;  **********
;
N_TWOSL:   DD      2
        DB      "2/"
TWOSL:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MSLAS-(CW*(C_HOFFSET))
        DD    N_TWOSL

        DD      STOD, TWO, FMSLAS
        DD      SWAP, DROP
        DD      SEMIS
;

;  **********
;  *   2*   *
;  **********
;
N_TWOST:   DD      2
        DB      "2*"
TWOST:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TWOSL-(CW*(C_HOFFSET))
        DD    N_TWOST

        DD      TWO, STAR
        DD      SEMIS
;

;  **********
;  *   1-   *
;  **********
;
N_ONEM:   DD      2
        DB      "1-"
ONEM:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TWOST-(CW*(C_HOFFSET))
        DD    N_ONEM

        DD      ONE, LSUB
        DD      SEMIS
;
;

;  **************
;  *   FM/MOD   *
;  **************
;
N_FMSLAS:   DD      6
        DB      "FM/MOD"
FMSLAS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ONEM-(CW*(C_HOFFSET))
        DD    N_FMSLAS

        DD      LDUP, TOR
        DD      TDUP, LXOR, TOR
        DD      MSLAS
        DD      FROMR, ZLESS
        DD      ZBRAN
        DD      FMMOD1-$-CW
        DD      OVER
        DD      ZBRAN
        DD      FMMOD1-$-CW
        DD      ONE, LSUB
        DD      SWAP, FROMR, PLUS, SWAP
        DD      BRAN
        DD      FMMOD2-$-CW
FMMOD1:
        DD      RDROP
FMMOD2:
        DD      SEMIS
;

;  *********
;  *   *   *
;  *********
;
N_STAR:   DD      1
        DB      "*"
STAR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FMSLAS-(CW*(C_HOFFSET))
        DD    N_STAR

        DD      MSTAR
        DD      DROP
        DD      SEMIS
;

;  ************
;  *   /MOD   *
;  ************
;
N_SLMOD:   DD      4
        DB      "/MOD"
SLMOD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    STAR-(CW*(C_HOFFSET))
        DD    N_SLMOD

        DD      TOR
        DD      STOD
        DD      FROMR
        DD      MSLAS
        DD      SEMIS
;

;  *********
;  *   /   *
;  *********
;
N_SLASH:   DD      1
        DB      "/"
SLASH:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SLMOD-(CW*(C_HOFFSET))
        DD    N_SLASH

        DD      SLMOD
        DD      SWAP
        DD      DROP
        DD      SEMIS
;

;  ***********
;  *   MOD   *
;  ***********
;
N_LMOD:   DD      3
        DB      "MOD"
LMOD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SLASH-(CW*(C_HOFFSET))
        DD    N_LMOD

        DD      SLMOD
        DD      DROP
        DD      SEMIS
;

;  *************
;  *   */MOD   *
;  *************
;
N_SSMOD:   DD      5
        DB      "*/MOD"
SSMOD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LMOD-(CW*(C_HOFFSET))
        DD    N_SSMOD

        DD      TOR
        DD      MSTAR
        DD      FROMR
        DD      MSLAS
        DD      SEMIS
;

;  **********
;  *   */   *
;  **********
;
N_SSLA:   DD      2
        DB      "*/"
SSLA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SSMOD-(CW*(C_HOFFSET))
        DD    N_SSLA

        DD      SSMOD
        DD      SWAP
        DD      DROP
        DD      SEMIS
;

;  *************
;  *   M/MOD   *
;  *************
;
N_MSMOD:   DD      5
        DB      "M/MOD"
MSMOD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SSLA-(CW*(C_HOFFSET))
        DD    N_MSMOD

        DD      TOR
        DD      ZERO
        DD      RR
        DD      USLAS
        DD      FROMR
        DD      SWAP
        DD      TOR
        DD      USLAS
        DD      FROMR
        DD      SEMIS
;

;  **************
;  *   (LINE)   *
;  **************
;
N_PLINE:   DD      6
        DB      "(LINE)"
PLINE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MSMOD-(CW*(C_HOFFSET))
        DD    N_PLINE

        DD      TOR
        DD      LIT,64
        DD      MSTAR
        DD      BBUF
        DD      FMSLAS
        DD      FROMR ; This blocks, so is screens.
        DD      PLUS
        DD      BLOCK
        DD      PLUS
        DD      LIT,63
        DD      SEMIS
;

;  **************
;  *   ERRSCR   *
;  **************
;
N_ERRSCR:   DD      6
        DB      "ERRSCR"
ERRSCR:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PLINE-(CW*(C_HOFFSET))
        DD    N_ERRSCR

        DD ERRORSCREEN
;

;  ***************
;  *   MESSAGE   *
;  ***************
;
N_MESS:   DD      7
        DB      "MESSAGE"
MESS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ERRSCR-(CW*(C_HOFFSET))
        DD    N_MESS

        DD      LWARN
        DD      FETCH
        DD      ZBRAN
        DD      MESS1-$-CW ;IF
        DD      ERRSCR, FETCH
        DD      PLINE, ONEP     ; Also print the '\n' !
        DD      ETYPE
        DD      X
MESS1:                  ;THEN
        DD      DROP
        DD      CR
        DD      SEMIS
;

;  ***********
;  *   PC@   *
;  ***********
;
N_PCFET:   DD      3
        DB      "PC@"
PCFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MESS-(CW*(C_HOFFSET))
        DD    N_PCFET

; FETCH CHARACTER (BYTE) FROM PORT
        POP     EDX      ; PORT ADDR
        XOR     EAX,EAX
        IN      AL,DX  ; BYTE INPUT
        PUSH    EAX
        JMP NEXT
;

;  ***********
;  *   PC!   *
;  ***********
;
N_PCSTO:   DD      3
        DB      "PC!"
PCSTO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PCFET-(CW*(C_HOFFSET))
        DD    N_PCSTO

        POP     EDX      ;PORT ADDR
        POP     EAX      ;DATA
        OUT     DX,AL   ; BYTE OUTPUT
        JMP NEXT
;

;  **********
;  *   P@   *
;  **********
;
N_PFET:   DD      2
        DB      "P@"
PFET:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PCSTO-(CW*(C_HOFFSET))
        DD    N_PFET

        POP     EDX      ;PORT ADDR
        IN      EAX,DX  ;WORD INPUT
        PUSH    EAX
        JMP NEXT
;

;  **********
;  *   P!   *
;  **********
;
N_PSTO:   DD      2
        DB      "P!"
PSTO:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PFET-(CW*(C_HOFFSET))
        DD    N_PSTO

        POP     EDX      ;PORT ADDR
        POP     EAX      ;DATA
        OUT     DX,EAX   ;WORD OUTPUT
        JMP NEXT
;

;  ***************
;  *   STALEST   *
;  ***************
;
N_STALEST:   DD      7
        DB      "STALEST"
STALEST:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PSTO-(CW*(C_HOFFSET))
        DD    N_STALEST

        DD BUF1
;

;  ************
;  *   PREV   *
;  ************
;
N_PREV:   DD      4
        DB      "PREV"
PREV:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    STALEST-(CW*(C_HOFFSET))
        DD    N_PREV

        DD      BUF1
;

;  *************
;  *   #BUFF   *
;  *************
;
N_NOBUF:   DD      5
        DB      "#BUFF"
NOBUF:        DD    DOCON
        DD    NBUF
        DD    0H
        DD    PREV-(CW*(C_HOFFSET))
        DD    N_NOBUF

;

;  ************
;  *   +BUF   *
;  ************
;
N_PBUF:   DD      4
        DB      "+BUF"
PBUF:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    NOBUF-(CW*(C_HOFFSET))
        DD    N_PBUF

        DD      LIT,(KBBUF+2*CW)
        DD      PLUS,LDUP
        DD      LIMIT,EQUAL
        DD      ZBRAN
        DD      PBUF1-$-CW
        DD      DROP,FIRST
PBUF1:  DD      LDUP, PREV, FETCH, LSUB
        DD      SEMIS
;

;  **************
;  *   UPDATE   *
;  **************
;
N_UPDAT:   DD      6
        DB      "UPDATE"
UPDAT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PBUF-(CW*(C_HOFFSET))
        DD    N_UPDAT

        DD      PREV, FETCH
        DD      LDUP, CELLP,CELLP
        DD      SWAP, FETCH
        DD      LOFFSET,  FETCH, PLUS
        DD      ZERO
        DD      RSLW
        DD      SEMIS
;

;  *********************
;  *   EMPTY-BUFFERS   *
;  *********************
;
N_MTBUF:   DD      13
        DB      "EMPTY-BUFFERS"
MTBUF:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    UPDAT-(CW*(C_HOFFSET))
        DD    N_MTBUF

        DD      FIRST
        DD      LIMIT,OVER
        DD      LSUB,LERASE
        DD      SEMIS
        ;
;

;  ****************
;  *   (BUFFER)   *
;  ****************
;
N_BUFFER:   DD      8
        DB      "(BUFFER)"
BUFFER:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MTBUF-(CW*(C_HOFFSET))
        DD    N_BUFFER

; Find the buffer, if it is already here.
    DD      PREV, FETCH
BUFFER1:
    DD          TOR, RR, FETCH, OVER, EQUAL
    DD      ZBRAN
        DD      BUFFER3-$-CW
    DD        DROP, FROMR, EXIT
BUFFER3:
    DD          FROMR
    DD      PBUF, ZEQU
    DD      ZBRAN
        DD      BUFFER1-$-CW
    DD       DROP
; Just allocate the stalest buffer.
    DD       STALEST,   FETCH, TOR
; Remember the next stalest buffer. 
    DD       RR
BUFFER2:
    DD       PBUF, OVER, CELLP, FETCH,
    DD       LIT, -1, GREAT, LAND
    DD      ZBRAN
        DD      BUFFER2-$-CW
    DD       STALEST, STORE
; Fill in the house keeping.
    DD       RR, STORE
    DD       ZERO, RR, CELLP, STORE
    DD       RR, PREV, STORE
    DD       FROMR
    DD  SEMIS
;


;  *************
;  *   BLOCK   *
;  *************
;
N_BLOCK:   DD      5
        DB      "BLOCK"
BLOCK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BUFFER-(CW*(C_HOFFSET))
        DD    N_BLOCK


        DD      BUFFER
        DD      LDUP, CELLP, FETCH, ZEQU
        DD      ZBRAN
        DD      BLOCK1-$-CW
        DD      LDUP, CELLP, CELLP
        DD      OVER, FETCH
        DD      LOFFSET,  FETCH, PLUS
        DD      ONE
        DD      RSLW
        DD      ONE, OVER, CELLP, STORE
BLOCK1:
        DD      LDUP, PREV, STORE
        DD      CELLP, CELLP
        DD      SEMIS
;

;  *************
;  *   FLUSH   *
;  *************
;
N_FLUSH:   DD      5
        DB      "FLUSH"
FLUSH:        DD    DOCOL
        DD    (MTBUF+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    0H
        DD    BLOCK-(CW*(C_HOFFSET))
        DD    N_FLUSH


; Unlock all buffers
        DD      LIMIT
        DD      FIRST, CELLP
        DD     XDO
        DD      FLUS2-$-CW
FLUS1:  DD      ZERO, IDO, STORE
        DD      LIT,(KBBUF+2*CW)
        DD      PLOOP
        DD      (FLUS1-$)
FLUS2:
        DD      SEMIS
;

;  ************
;  *   SAVE   *
;  ************
;
N_SAVE:   DD      4
        DB      "SAVE"
SAVE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FLUSH-(CW*(C_HOFFSET))
        DD    N_SAVE

        DD      FROMR
        DD      SRC, TFET
        DD      LIN, FETCH
        DD      TOR, TOR, TOR
        DD      TOR
        DD SEMIS
;

;  ***************
;  *   RESTORE   *
;  ***************
;
N_RESTO:   DD      7
        DB      "RESTORE"
RESTO:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SAVE-(CW*(C_HOFFSET))
        DD    N_RESTO

        DD      FROMR
        DD      FROMR, FROMR, FROMR
        DD      LIN, STORE
        DD      SRC, TSTOR
        DD      TOR
        DD SEMIS
;


;  ******************
;  *   SAVE-INPUT   *
;  ******************
;
N_SAVEI:   DD      10
        DB      "SAVE-INPUT"
SAVEI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RESTO-(CW*(C_HOFFSET))
        DD    N_SAVEI

        DD      SRC, TFET
        DD      LIN, FETCH
        DD      LIT, 3
        DD SEMIS
;

;  *********************
;  *   RESTORE-INPUT   *
;  *********************
;
N_RESTOI:   DD      13
        DB      "RESTORE-INPUT"
RESTOI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SAVEI-(CW*(C_HOFFSET))
        DD    N_RESTOI

        DD      DROP
        DD      LIN, STORE
        DD      SRC, TSTOR
        DD SEMIS
;
;

;  ************
;  *   LOCK   *
;  ************
;
N_LLOCK:   DD      4
        DB      "LOCK"
LLOCK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RESTOI-(CW*(C_HOFFSET))
        DD    N_LLOCK

        DD      BLOCK
        DD      LIT, CW, LSUB
        DD      LIT, -2, SWAP, PSTORE
        DD      SEMIS
;

;  **************
;  *   UNLOCK   *
;  **************
;
N_LUNLOCK:   DD      6
        DB      "UNLOCK"
LUNLOCK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LLOCK-(CW*(C_HOFFSET))
        DD    N_LUNLOCK

        DD      BLOCK
        DD      LIT, CW, LSUB
        DD      TWO, SWAP, PSTORE
        DD      SEMIS
;

;  ************
;  *   LOAD   *
;  ************
;
N_LOAD:   DD      4
        DB      "LOAD"
LOAD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LUNLOCK-(CW*(C_HOFFSET))
        DD    N_LOAD

        DD      LDUP, THRU
        DD      SEMIS
;

;  ************
;  *   THRU   *
;  ************
;
N_THRU:   DD      4
        DB      "THRU"
THRU:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LOAD-(CW*(C_HOFFSET))
        DD    N_THRU

        DD      SAVE
        DD      ONEP, SWAP
        DD     XDO
        DD      THRU2-$-CW
THRU1:
        DD      IDO, LLOCK
        DD      IDO, BLOCK
        DD      LIT, KBBUF
        DD      SETSRC
        DD      LIT, INTER, CATCH
        DD      IDO, LUNLOCK
        DD      QDUP
        DD      ZBRAN
        DD      THRU3-$-CW
        DD      RDROP, RDROP, RDROP; UNLOOP.
        DD      RESTO
        DD      THROW
THRU3:
        DD     XLOOP
        DD      THRU1-$-CW
THRU2:
        DD      RESTO
        DD      SEMIS
;

;

;  ***********
;  *   BLK   *
;  ***********
;
N_BLK:   DD      3
        DB      "BLK"
BLK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    THRU-(CW*(C_HOFFSET))
        DD    N_BLK

        DD      LIN, FETCH
        DD      FIRST, LIMIT, WITHIN
        DD      SRC, TFET, LSUB
        DD      LIT, 1024, EQUAL, LAND
        DD      ZBRAN
        DD      BLK1-$-CW
        DD      SRC, FETCH, TWO, LCELLS, LSUB, FETCH
        DD      BRAN
        DD      BLK2-$-CW
BLK1:
        DD      ZERO
BLK2:
        DD      PBLK, STORE
        DD      PBLK
        DD      SEMIS
;

;  ***********
;  *   -->   *
;  ***********
;
N_ARROW:   DD      3
        DB      "-->"
ARROW:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    BLK-(CW*(C_HOFFSET))
        DD    N_ARROW

        DD      QLOAD
        DD      BLK, FETCH
        DD      LDUP, LUNLOCK
        DD      ONEP
        DD      LDUP, LLOCK
        DD      LDUP, BLK, STORE
        DD      BLOCK
        DD      LIT, KBBUF
        DD      SETSRC
        DD      SEMIS
        ;
;
;
; 


;  *************
;  *   LINOS   *
;  *************
;
N_LINOS:   DD      5
        DB      "LINOS"
LINOS:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ARROW-(CW*(C_HOFFSET))
        DD    N_LINOS

        POP     EAX        ; Function number
        POP     EDX        ; Third parameter, if any
        POP     ECX        ; Second parameter, if any
        POP     EBX        ; First parameter.
        INT     80H        ; Generic call on LINUX 
        PUSH    EAX
        JMP NEXT     ; Positive means okay. Negative means -errno.
;

;  **************
;  *   LINOS5   *
;  **************
;
N_LINOS5:   DD      6
        DB      "LINOS5"
LINOS5:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LINOS-(CW*(C_HOFFSET))
        DD    N_LINOS5

        LEA     EBP,[EBP - (CW*(1))] ;Save HIP on return stack.
        MOV     [EBP],ESI
        POP     EAX        ; Function number
        POP     EDI        ; 5th parameter, if any
        POP     ESI        ; 4th parameter, if any
        POP     EDX        ; Third parameter, if any
        POP     ECX        ; Second parameter, if any
        POP     EBX        ; First parameter.
        INT     80H        ; Generic call on LINUX 
        MOV     ESI,[EBP]    ; Restore
        LEA     EBP,[EBP+(CW*(1))]
        PUSH    EAX
        JMP NEXT     ; Positive means okay. Negative means -errno.
;

;  **********
;  *   MS   *
;  **********
;
N_MS:   DD      2
        DB      "MS"
MS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LINOS5-(CW*(C_HOFFSET))
        DD    N_MS

        DD      LIT, 1000, LIT, 1000000, SSMOD ; (ms -- us s) 
        DD      LIT, TV, TSTOR
        DD      ZERO, ZERO
        DD      ZERO, ZERO
        DD      LIT, TV
        DD      LIT, _newselect, LINOS5
        DD      QERRUR
        DD      SEMIS
TV:     RESB    8 
;
; 
        ;
;------------------------------------
;       SYSTEM DEPENDANT CHAR I/O
;------------------------------------
;
;
;

; Code fields are filled in during bootup. 
; Lower case labels starting with "c_.." are c-supplied facilities.

;  ****************
;  *   (ACCEPT)   *
;  ****************
;
N_PACCEP:   DD      8
        DB      "(ACCEPT)"
PACCEP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    MS-(CW*(C_HOFFSET))
        DD    N_PACCEP

        DD      TIB
        DD      FETCH
        DD      LDUP
        DD      LIT,RTS/2
        DD      ACCEP
; Keep the next line in for debugging ACCEPT for MSDOS.
;        DD      LIT, 41H, EMIT, TDUP, LTYPE, LIT, 41H, EMIT
;        DD      DOTS
        DD      SEMIS
;

;  **************
;  *   ACCEPT   *
;  **************
;
N_ACCEP:   DD      6
        DB      "ACCEPT"
ACCEP:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PACCEP-(CW*(C_HOFFSET))
        DD    N_ACCEP

        CALL    c_expec
        LEA     ESP,[ESP+(CW*(2))]    ; remove input
        PUSH    EAX
        JMP NEXT
;

;  ***********
;  *   KEY   *
;  ***********
;
N_KEY:   DD      3
        DB      "KEY"
KEY:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ACCEP-(CW*(C_HOFFSET))
        DD    N_KEY

        CALL    c_key
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   KEY?   *
;  ************
;
N_KEYQ:   DD      4
        DB      "KEY?"
KEYQ:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    KEY-(CW*(C_HOFFSET))
        DD    N_KEYQ

        CALL    c_qterm
        PUSH    EAX
        JMP NEXT
;

;  ************
;  *   TYPE   *
;  ************
;
N_LTYPE:   DD      4
        DB      "TYPE"
LTYPE:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    KEYQ-(CW*(C_HOFFSET))
        DD    N_LTYPE

        CALL    c_type
        LEA     ESP,[ESP+(CW*(2))]    ; remove input
        JMP NEXT
;
 ; 
;


;  ************
;  *   EMIT   *
;  ************
;
N_EMIT:   DD      4
        DB      "EMIT"
EMIT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LTYPE-(CW*(C_HOFFSET))
        DD    N_EMIT

        DD      SPFET, ONE, LTYPE
        DD      DROP
        DD      SEMIS
;
;
;
;
;
;
;

        ;
;------------------------------------
;       SYSTEM DEPENDANT DISK I/O
;------------------------------------


;  ******************
;  *   DISK-ERROR   *
;  ******************
;
N_DERR:   DD      10
        DB      "DISK-ERROR"
DERR:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    EMIT-(CW*(C_HOFFSET))
        DD    N_DERR

        DD      -1
;


;  ******************
;  *   BLOCK-FILE   *
;  ******************
;
N_BLFL:   DD      10
        DB      "BLOCK-FILE"
BLFL:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DERR-(CW*(C_HOFFSET))
        DD    N_BLFL

        DD      9
        DB      "forth.lab"
        RESB    254-9               ; Allow for some path

;  ********************
;  *   BLOCK-HANDLE   *
;  ********************
;
N_BHAN:   DD      12
        DB      "BLOCK-HANDLE"
BHAN:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BLFL-(CW*(C_HOFFSET))
        DD    N_BHAN

        DD      -1
;

;  *******************
;  *   ?DISK-ERROR   *
;  *******************
;
N_QDSKER:   DD      11
        DB      "?DISK-ERROR"
QDSKER:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BHAN-(CW*(C_HOFFSET))
        DD    N_QDSKER

        DD      LIT, 8, QERR
        DD      SEMIS
;

;  ******************
;  *   BLOCK-INIT   *
;  ******************
;
N_BLINI:   DD      10
        DB      "BLOCK-INIT"
BLINI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QDSKER-(CW*(C_HOFFSET))
        DD    N_BLINI

        DD      BLFL, SFET
        DD      ROT
        DD      OFILE
        DD      ZEQU, NEGATE  ; 0 if disk problems, 1 if not.
        DD      LWARN, FETCH, MIN ; Affect WARNING only if it was 1.
        DD      LWARN, STORE
        DD      BHAN, STORE
        DD      SEMIS
;

;  ******************
;  *   BLOCK-EXIT   *
;  ******************
;
N_BLEXI:   DD      10
        DB      "BLOCK-EXIT"
BLEXI:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BLINI-(CW*(C_HOFFSET))
        DD    N_BLEXI

        DD      FLUSH
        DD      BHAN, FETCH
        DD      CFILE
        DD      ZERO, LWARN, FETCH, MIN
        DD      LWARN, STORE            ; Affect WARNING only if it was 1.
        DD      LIT, -1, BHAN, STORE    ;Regardless of close errors.
        DD      QDSKER
        DD      SEMIS
;

;  ************
;  *   SEEK   *
;  ************
;
N_SEEK:   DD      4
        DB      "SEEK"
SEEK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BLEXI-(CW*(C_HOFFSET))
        DD    N_SEEK

        DD      BBUF
        DD      USTAR
        DD      BHAN, FETCH
        DD      PFILE           ; Disk position.
        DD      QDSKER
        DD      SEMIS
;

;  ***********
;  *   R\W   *
;  ***********
;
N_RSLW:   DD      3
        DB      "R\W"
RSLW:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SEEK-(CW*(C_HOFFSET))
        DD    N_RSLW

        DD      TOR ; blk on top
        DD      SEEK ; That's done
        DD      BBUF
        DD      BHAN, FETCH
        DD      FROMR
        DD      ZBRAN
        DD      RSLW1-$-CW
        DD      RFILE           ; Disk read 
        DD      SWAP, DROP
        DD      BRAN
        DD      RSLW2-$-CW
RSLW1:  DD      WFILE           ; Disk write
RSLW2:
        DD      QDSKER
        DD      SEMIS
;
;

;  *************
;  *   SHELL   *
;  *************
;
N_SHELL:   DD      5
        DB      "SHELL"
SHELL:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    RSLW-(CW*(C_HOFFSET))
        DD    N_SHELL

                 DD      7
        DB      "/bin/sh"
        
        RESB    254-9               ; Allow for some path
;

;
;


;  ******************
;  *   BLOCK-INIT   *
;  ******************
;
N_BLINI:   DD      10
        DB      "BLOCK-INIT"
BLINI:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SHELL-(CW*(C_HOFFSET))
        DD    N_BLINI

        MOV     EAX,[(BLFL+(CW*(PH_OFFSET-C_HOFFSET)))]
        MOV     EBX,(BLFL+(CW*(PH_OFFSET-C_HOFFSET)))+CW
        PUSH    EBX
        PUSH    EAX
        CALL    c_block_init
        MOV     [(DERR+(CW*(PH_OFFSET-C_HOFFSET)))],EAX
        LEA     ESP,[ESP+(CW*(2))]    ; remove input
        JMP NEXT
;

;  ******************
;  *   BLOCK-EXIT   *
;  ******************
;
N_BLEXI:   DD      10
        DB      "BLOCK-EXIT"
BLEXI:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BLINI-(CW*(C_HOFFSET))
        DD    N_BLEXI

        CALL    c_block_exit
        JMP NEXT
;

;      ( ADDR  BLK#  FLAG (0=W, 1=R)
;  ***********
;  *   R\W   *
;  ***********
;
N_RSLW:   DD      3
        DB      "R\W"
RSLW:        DD    $+(CW*(PH_OFFSET-C_HOFFSET))
        DD    $+(CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BLEXI-(CW*(C_HOFFSET))
        DD    N_RSLW

        CALL c_rslw
        MOV     [(DERR+(CW*(PH_OFFSET-C_HOFFSET)))],EAX
        LEA     ESP,[ESP+(CW*(3))]    ; remove input
        JMP NEXT


 ; 
; 
;
;
;
; 
; 
;


;  ***********
;  *   [']   *
;  ***********
;
N_BTICK:   DD      3
        DB      "[']"
BTICK:        DD    DOCOL
        DD    (TICK+(CW*(PH_OFFSET-C_HOFFSET)))
        DD    B_IMMED
        DD    RSLW-(CW*(C_HOFFSET))
        DD    N_BTICK

;
;

;  ******************
;  *   FORGET-VOC   *
;  ******************
;
N_FORGV:   DD      10
        DB      "FORGET-VOC"
FORGV:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BTICK-(CW*(C_HOFFSET))
        DD    N_FORGV

        DD      TDUP
        DD      SWAP
        DD      ULESS
        DD      ZBRAN
        DD      FORGV1-$-CW
;  Forget part of contents.
        DD      SWAP
        DD      TOR
        DD      TWID
        DD      LDUP
FORGV3:
        DD      TLFA,FETCH    ; Next voc
        DD      LDUP
        DD      RR
        DD      ULESS
        DD      ZBRAN
        DD      FORGV3-$-CW
        DD      SWAP
        DD      TLFA
        DD      STORE
        DD      FROMR
        DD      BRAN
        DD      FORGV2-$-CW
FORGV1:
;        Vocabulary itself is also forgotten.
        DD      TVFA
        DD      FETCH     ; Unlink by linking next vocabulary.
        DD      VOCL
        DD      STORE
        DD      ONLY, FORTH
        DD      DEFIN
FORGV2: DD      SEMIS
;

;  **************
;  *   FORGET   *
;  **************
;
N_FORG:   DD      6
        DB      "FORGET"
FORG:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FORGV-(CW*(C_HOFFSET))
        DD    N_FORG

        DD      TICK
        DD      LDUP
        DD      FENCE
        DD      FETCH
        DD      LESS
        DD      LIT, 21, QERR
        DD      LIT,FORGV
        DD      FORV
        DD      TNFA, FETCH, LDP, STORE
        DD      SEMIS
;

;  *************
;  *   (BACK   *
;  *************
;
N_PBACK:   DD      5
        DB      "(BACK"
PBACK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FORG-(CW*(C_HOFFSET))
        DD    N_PBACK

        DD      HERE
        DD      SEMIS
;

;  *************
;  *   BACK)   *
;  *************
;
N_BACKP:   DD      5
        DB      "BACK)"
BACKP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PBACK-(CW*(C_HOFFSET))
        DD    N_BACKP

        DD      HERE
        DD      CELLP
        DD      LSUB
        DD      COMMA
        DD      SEMIS
;

;  ****************
;  *   (FORWARD   *
;  ****************
;
N_PFORWARD:   DD      8
        DB      "(FORWARD"
PFORWARD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BACKP-(CW*(C_HOFFSET))
        DD    N_PFORWARD

        DD      HERE
        DD      X
        DD      COMMA
        DD      SEMIS
;

;  ****************
;  *   FORWARD)   *
;  ****************
;
N_FORWARDP:   DD      8
        DB      "FORWARD)"
FORWARDP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PFORWARD-(CW*(C_HOFFSET))
        DD    N_FORWARDP

        DD      HERE
        DD      OVER
        DD      CELLP
        DD      LSUB
        DD      SWAP
        DD      STORE
        DD      SEMIS
;

;  *************
;  *   BEGIN   *
;  *************
;
N_BEGIN:   DD      5
        DB      "BEGIN"
BEGIN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    FORWARDP-(CW*(C_HOFFSET))
        DD    N_BEGIN

        DD      PBACK
        DD      QCOMP, ONE
        DD      SEMIS
;

;  ************
;  *   THEN   *
;  ************
;
N_THEN:   DD      4
        DB      "THEN"
THEN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    BEGIN-(CW*(C_HOFFSET))
        DD    N_THEN

        DD      QCOMP, TWO, QPAIR
        DD      FORWARDP
        DD      SEMIS
;

;  **********
;  *   DO   *
;  **********
;
N_DO:   DD      2
        DB      "DO"
DO:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    THEN-(CW*(C_HOFFSET))
        DD    N_DO

         DD      LIT, XDO, COMMA, PFORWARD, PBACK
        DD      LIT,3    ; Magic number
        DD      SEMIS
;

;  ***********
;  *   ?DO   *
;  ***********
;
N_QDO:   DD      3
        DB      "?DO"
QDO:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    DO-(CW*(C_HOFFSET))
        DD    N_QDO

         DD      LIT, XQDO, COMMA, PFORWARD, PBACK
        DD      LIT,3    ; Magic number
        DD      SEMIS
;

;  ************
;  *   LOOP   *
;  ************
;
N_LLOOP:   DD      4
        DB      "LOOP"
LLOOP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    QDO-(CW*(C_HOFFSET))
        DD    N_LLOOP

        DD      LIT, 3, QPAIR
        DD      LIT, XLOOP, COMMA, BACKP
        DD      FORWARDP ; For DO to push the leave address.
        DD      SEMIS
;

;  *************
;  *   +LOOP   *
;  *************
;
N_PLOOP:   DD      5
        DB      "+LOOP"
PLOOP:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    LLOOP-(CW*(C_HOFFSET))
        DD    N_PLOOP

        DD      LIT, 3, QPAIR
        DD      LIT, XPLOO, COMMA, BACKP
        DD      FORWARDP ; For DO to push the leave address.
        DD      SEMIS
;

;  *************
;  *   UNTIL   *
;  *************
;
N_UNTIL:   DD      5
        DB      "UNTIL"
UNTIL:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    PLOOP-(CW*(C_HOFFSET))
        DD    N_UNTIL

        DD      ONE, QPAIR
        DD      LIT, ZBRAN, COMMA, BACKP
        DD      SEMIS
;

;  *************
;  *   AGAIN   *
;  *************
;
N_AGAIN:   DD      5
        DB      "AGAIN"
AGAIN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    UNTIL-(CW*(C_HOFFSET))
        DD    N_AGAIN

        DD      ONE, QPAIR
        DD      LIT, BRAN, COMMA, BACKP
        DD      SEMIS
;

;  **************
;  *   REPEAT   *
;  **************
;
N_REPEA:   DD      6
        DB      "REPEAT"
REPEA:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    AGAIN-(CW*(C_HOFFSET))
        DD    N_REPEA

        DD      ONE, QPAIR   ; Matches BEGIN ?
        DD      LIT, BRAN, COMMA, BACKP
        DD      QCOMP, LIT, 4, QPAIR ; Matches WHILE ?
        DD      FORWARDP ; WHILE target. 
        DD      SEMIS
;

;  **********
;  *   IF   *
;  **********
;
N_LIF:   DD      2
        DB      "IF"
LIF:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    REPEA-(CW*(C_HOFFSET))
        DD    N_LIF

        DD      LIT, ZBRAN, COMMA, PFORWARD
        DD      TWO     ; Magic number
        DD      SEMIS
;

;  ************
;  *   ELSE   *
;  ************
;
N_LELSE:   DD      4
        DB      "ELSE"
LELSE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    LIF-(CW*(C_HOFFSET))
        DD    N_LELSE

        DD      QCOMP, TWO, QPAIR
        DD      LIT, BRAN, COMMA, PFORWARD
        DD      SWAP
        DD      FORWARDP
        DD      TWO     ; Magic number
        DD      SEMIS
;

;  *************
;  *   WHILE   *
;  *************
;
N_LWHILE:   DD      5
        DB      "WHILE"
LWHILE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    B_IMMED
        DD    LELSE-(CW*(C_HOFFSET))
        DD    N_LWHILE

        DD      TOR    ;  Save backward target. 
        DD      TOR
        DD      LIT, ZBRAN, COMMA, PFORWARD
        DD      LIT, 4 ; Magic number
        DD      FROMR
        DD      FROMR
        DD      SEMIS
;

;  **************
;  *   SPACES   *
;  **************
;
N_SPACES:   DD      6
        DB      "SPACES"
SPACES:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LWHILE-(CW*(C_HOFFSET))
        DD    N_SPACES

        DD      ZERO
        DD      MAX
        DD      QDUP
        DD      ZBRAN
        DD      SPAX1-$-CW
        DD      ZERO
        DD     XDO
        DD      SPAX1-$-CW
SPAX2:  DD      SPACE
        DD     XLOOP
        DD      SPAX2-$-CW    ;LOOP
SPAX1:
        DD      SEMIS
;

;  **********
;  *   <#   *
;  **********
;
N_BDIGS:   DD      2
        DB      "<#"
BDIGS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SPACES-(CW*(C_HOFFSET))
        DD    N_BDIGS

        DD      PAD
        DD      HLD
        DD      STORE
        DD      SEMIS
;

;  **********
;  *   #>   *
;  **********
;
N_EDIGS:   DD      2
        DB      "#>"
EDIGS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BDIGS-(CW*(C_HOFFSET))
        DD    N_EDIGS

        DD      DROP
        DD      DROP
        DD      HLD
        DD      FETCH
        DD      PAD
        DD      OVER
        DD      LSUB
        DD      SEMIS
;

;  ************
;  *   SIGN   *
;  ************
;
N_SIGN:   DD      4
        DB      "SIGN"
SIGN:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    EDIGS-(CW*(C_HOFFSET))
        DD    N_SIGN

        DD      ZLESS
        DD      ZBRAN
        DD      SIGN1-$-CW ;IF
        DD      LIT,2DH
        DD      HOLD    ;THEN
SIGN1:  DD      SEMIS
;

;  *********
;  *   #   *
;  *********
;
N_DIG:   DD      1
        DB      "#"
DIG:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SIGN-(CW*(C_HOFFSET))
        DD    N_DIG

        DD      BASE
        DD      FETCH
        DD      MSMOD
        DD      ROT
        DD      LIT,9
        DD      OVER
        DD      LESS
        DD      ZBRAN
        DD      DIG1-$-CW  ;IF
        DD      LIT,7
        DD      PLUS    ;THEN
DIG1:   DD      LIT,30H
        DD      PLUS
        DD      HOLD
        DD      SEMIS
;

;  **********
;  *   #S   *
;  **********
;
N_DIGS:   DD      2
        DB      "#S"
DIGS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DIG-(CW*(C_HOFFSET))
        DD    N_DIGS

DIGS1:  DD      DIG     ;BEGIN
        DD      OVER
        DD      OVER
        DD      LOR
        DD      ZEQU
        DD      ZBRAN
        DD      DIGS1-$-CW ;UNTIL
        DD      SEMIS
;

;  *************
;  *   (D.R)   *
;  *************
;
N_PDDOTR:   DD      5
        DB      "(D.R)"
PDDOTR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DIGS-(CW*(C_HOFFSET))
        DD    N_PDDOTR

        DD      TOR
        DD      SWAP
        DD      OVER
        DD      DABS
        DD      BDIGS
        DD      DIGS
        DD      ROT
        DD      SIGN
        DD      EDIGS
        DD      FROMR
        DD      OVER
        DD      LSUB
        DD      SPACES
        DD      SEMIS
;

;  ***********
;  *   D.R   *
;  ***********
;
N_DDOTR:   DD      3
        DB      "D.R"
DDOTR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    PDDOTR-(CW*(C_HOFFSET))
        DD    N_DDOTR

        DD      PDDOTR
        DD      LTYPE
        DD      SEMIS
;

;  **********
;  *   .R   *
;  **********
;
N_DOTR:   DD      2
        DB      ".R"
DOTR:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DDOTR-(CW*(C_HOFFSET))
        DD    N_DOTR

        DD      TOR
        DD      STOD
        DD      FROMR
        DD      DDOTR
        DD      SEMIS
;

;  **********
;  *   D.   *
;  **********
;
N_DDOT:   DD      2
        DB      "D."
DDOT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DOTR-(CW*(C_HOFFSET))
        DD    N_DDOT

        DD      ZERO
        DD      DDOTR
        DD      SPACE
        DD      SEMIS
;

;  *********
;  *   .   *
;  *********
;
N_DOT:   DD      1
        DB      "."
DOT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DDOT-(CW*(C_HOFFSET))
        DD    N_DOT

        DD      STOD
        DD      DDOT
        DD      SEMIS
;

;  *********
;  *   ?   *
;  *********
;
N_QUES:   DD      1
        DB      "?"
QUES:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DOT-(CW*(C_HOFFSET))
        DD    N_QUES

        DD      FETCH
        DD      DOT
        DD      SEMIS
;

;  **********
;  *   U.   *
;  **********
;
N_UDOT:   DD      2
        DB      "U."
UDOT:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    QUES-(CW*(C_HOFFSET))
        DD    N_UDOT

        DD      ZERO
        DD      DDOT
        DD      SEMIS
;

;  *****************
;  *   FOR-WORDS   *
;  *****************
;
N_FORW:   DD      9
        DB      "FOR-WORDS"
FORW:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    UDOT-(CW*(C_HOFFSET))
        DD    N_FORW

        DD      SWAP
        DD      TOR
        DD      TOR
FORW1:  DD      FROMR
        DD      RR
        DD      OVER
        DD      TLFA
        DD      FETCH
        DD      TOR
        DD      EXEC
        DD      RR
        DD      ZEQU
        DD      ZBRAN
        DD      FORW1-$-CW
        DD      RDROP
        DD      RDROP
        DD      SEMIS
;

;  ****************
;  *   FOR-VOCS   *
;  ****************
;
N_FORV:   DD      8
        DB      "FOR-VOCS"
FORV:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FORW-(CW*(C_HOFFSET))
        DD    N_FORV

        DD      TOR
        DD      VOCL
        DD      FETCH
        DD      TOR
FORV1:  DD      FROMR
        DD      RR
        DD      OVER
        DD      TVFA
        DD      FETCH
        DD      TOR
        DD      EXEC
        DD      RR
        DD      ZEQU
        DD      ZBRAN
        DD      FORV1-$-CW
        DD      RDROP
        DD      RDROP
        DD      SEMIS
;

;  *************
;  *   WORDS   *
;  *************
;
N_WORDS:   DD      5
        DB      "WORDS"
WORDS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    FORV-(CW*(C_HOFFSET))
        DD    N_WORDS

        DD      CSLL
        DD      LOUT
        DD      STORE
        DD      LIT, IDDOT
        DD      SEARCH
        DD      FETCH
        DD      FORW
        DD      SEMIS
;
; 
; 

;  *****************
;  *   EXIT-CODE   *
;  *****************
;
N_XCODE:   DD      9
        DB      "EXIT-CODE"
XCODE:        DD    DOVAR
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    WORDS-(CW*(C_HOFFSET))
        DD    N_XCODE

        DD      0
;


;  ***********
;  *   BYE   *
;  ***********
;
N_BYE:   DD      3
        DB      "BYE"
BYE:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    XCODE-(CW*(C_HOFFSET))
        DD    N_BYE

; Exit to linux, with okay status. 
        DD      XCODE, FETCH, X, X, ONE, LINOS
        DD      SEMIS   ;Unnecessary, but helpful for decompilation.
; 
;

;  ************
;  *   LIST   *
;  ************
;
N_LLIST:   DD      4
        DB      "LIST"
LLIST:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    BYE-(CW*(C_HOFFSET))
        DD    N_LLIST

        DD      SCR,STORE
        DD      SKIP
         DD      6
SB5: DB      "SCR # "
       
        DD      LIT, SB5
        DD      LIT, 6
        DD      LTYPE
        DD      BASE, FETCH
        DD      DECA
        DD      SCR, FETCH, DOT
        DD      BASE, STORE
        DD      SCR, FETCH, BLOCK
        DD      LIT,1024
LLIST1: DD      LIT, ALF, SSPLIT
        DD      CR, LTYPE
        DD      OVER,ZEQU ;DUP would not show a last empty line!
        DD      ZBRAN
        DD      LLIST1-$-CW
        DD      TDROP
        DD      SEMIS
;

;  *************
;  *   INDEX   *
;  *************
;
N_INDEX:   DD      5
        DB      "INDEX"
INDEX:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    LLIST-(CW*(C_HOFFSET))
        DD    N_INDEX

        DD      LIT,AFF
        DD      EMIT,CR
        DD      ONEP,SWAP
        DD     XDO
        DD      INDE9-$-CW
INDE1:  DD      CR,IDO
        DD      LIT,3
        DD      DOTR,SPACE
        DD      ZERO,IDO
        DD      PLINE, LTYPE, KEYQ
        DD      ZBRAN
        DD      INDE2-$-CW
        DD      LLEAV
INDE2:  DD     XLOOP
        DD      INDE1-$-CW
INDE9:
        DD      SEMIS
;

;  **********
;  *   .S   *
;  **********
;
N_DOTS:   DD      2
        DB      ".S"
DOTS:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    INDEX-(CW*(C_HOFFSET))
        DD    N_DOTS

        DD      CR
        DD      LIT, 'S', EMIT
        DD      LIT, ASO, EMIT
        DD      SPACE
        DD      SPFET, SZERO, FETCH
DOC2:   DD      OVER, OVER,  EQUAL, ZEQU
        DD      ZBRAN
        DD      DOC1-$-CW
        DD      ZERO, CELLP, LSUB, LDUP, FETCH, DOT
        DD      BRAN
        DD      DOC2-$-CW
DOC1:    DD DROP, DROP
        DD      LIT, ASC, EMIT
        DD SEMIS
;

;  ********************
;  *   ENVIRONMENT?   *
;  ********************
;
N_ENVQ:   DD      12
        DB      "ENVIRONMENT?"
ENVQ:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    DOTS-(CW*(C_HOFFSET))
        DD    N_ENVQ

        DD      ZERO, RESULT, STORE
        DD      LIT, MATCHING
        DD      LIT, ENV
        DD      TWID, FORW, TDROP
        DD      RESULT, FETCH
        DD      LDUP
        DD      ZBRAN
        DD      ENVQ1-$-CW
        DD      EXEC
        DD      LIT, -1
        DD      BRAN
        DD      ENVQ2-$-CW
ENVQ1:  DD      DROP, ZERO
ENVQ2:
        DD      SEMIS
;


;  *************
;  *   TRIAD   *
;  *************
;
N_TRIAD:   DD      5
        DB      "TRIAD"
TRIAD:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    ENVQ-(CW*(C_HOFFSET))
        DD    N_TRIAD

        DD      LIT,AFF
        DD      EMIT
        DD      LIT,3
        DD      SLASH
        DD      LIT,3
        DD      STAR
        DD      LIT,3
        DD      OVER,PLUS
        DD      SWAP
        DD     XDO
        DD      TRIA9-$-CW
TRIA1:  DD      CR,IDO
        DD      LLIST
        DD      KEYQ
        DD      ZBRAN
        DD      TRIA2-$-CW
        DD      LLEAV   ;LEAVE
TRIA2:  DD     XLOOP
        DD      TRIA1-$-CW    ;THEN
TRIA9:
        DD      CR
        DD      SEMIS
;
;
; This word is not even fig!

;  ***************
;  *   .SIGNON   *
;  ***************
;
N_SIGNON:   DD      7
        DB      ".SIGNON"
SIGNON:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    TRIAD-(CW*(C_HOFFSET))
        DD    N_SIGNON

; PRINT CPU TYPE (8088)
        DD      CR
        DD      BASE,FETCH
        DD      LIT,36, BASE,STORE
        DD      CPU, DDOT
        DD      BASE,STORE
;
        DD      LNAME, LTYPE, SPACE
        DD      LVERSION, LTYPE, SPACE
        DD      CR
        DD      SEMIS
;
; 
;
;**** LAST DICTIONARY WORD ****

;  ************
;  *   TASK   *
;  ************
;
N_TASK:   DD      4
        DB      "TASK"
TASK:        DD    DOCOL
        DD    $ + (CW*(PH_OFFSET-D_HOFFSET))
        DD    0H
        DD    SIGNON-(CW*(C_HOFFSET))
        DD    N_TASK

        DD      SEMIS
;
 ;  

%if 0

The remaining memory ( up to 'EM' ) is
used for:

        1. EXTENSION DICTIONARY
        2. PARAMETER STACK
        3. TERMINAL INPUT BUFFER
        4. RETURN STACK
        5. USER VARIABLE AREA
        6. DISK BUFFERS (UNLESS REQUIRED <1 MBYTE)


%endif


;       This is the proper way to do it.
;       No memory addresses should be arrived at through equates.
;       However now we must teach the linker to keep the
;       two sections together.

FORTHSIZE       EQU     $ - ORG0
         section dictionary nobits write exec alloc

INITDP:                 ;  It may be that it is not consecutive with TASK.
                        ;  Because of bad linking, resulting in a unusable Forth.
        BUFFERSIZE      EQU  (KBBUF+2*CW)*NBUF

       RESB    EM - FORTHSIZE - RTS - US - BUFFERSIZE 
INITS0:                         ; Grows down
STRTIB: RESB    RTS             ; Start return stack area
INITR0:                         ; Grows down
STRUSA: RESB    US              ; User area
BUF1:   RESB    BUFFERSIZE      ; FIRST DISK BUFFER
ACTUAL_EM:  ; Differs from EM if code is relocated.
; 
;

 ;    ENDS
        ;
%if 0

  MISC. NOTES AND SCATTERED THOUGHTS

- Remember that all the FORTH words in this version are
  upper case letters.  Use <CAPS LOCK> when in FORTH.

; 

- Subscribe to FORTH Dimensions.  It is a valuable source
  of system and application ideas.  Talking with fellow
  FORTH programmers is sure to stir up some exciting ideas.
  Consider joining a FIG chapter.  See the back of FORTH
  Dimensions for more info.

%endif

; Define the entry point, not valid for auto booting.
        ;     ORIG























;




